/* remote-login-service.c generated by valac 0.32.1, the Vala compiler
 * generated from remote-login-service.vala, do not modify */

/* -*- Mode: Vala; indent-tabs-mode: nil; tab-width: 4 -*-
 *
 * Copyright (C) 2012 Canonical Ltd
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 3 as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>


#define TYPE_REMOTE_SERVER_FIELD (remote_server_field_get_type ())
typedef struct _RemoteServerField RemoteServerField;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))

#define TYPE_REMOTE_SERVER_APPLICATION (remote_server_application_get_type ())
typedef struct _RemoteServerApplication RemoteServerApplication;

#define TYPE_REMOTE_SERVER (remote_server_get_type ())
typedef struct _RemoteServer RemoteServer;

#define TYPE_REMOTE_LOGIN_SERVICE (remote_login_service_get_type ())
#define REMOTE_LOGIN_SERVICE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_REMOTE_LOGIN_SERVICE, RemoteLoginService))
#define IS_REMOTE_LOGIN_SERVICE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_REMOTE_LOGIN_SERVICE))
#define REMOTE_LOGIN_SERVICE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_REMOTE_LOGIN_SERVICE, RemoteLoginServiceIface))

typedef struct _RemoteLoginService RemoteLoginService;
typedef struct _RemoteLoginServiceIface RemoteLoginServiceIface;

#define TYPE_REMOTE_LOGIN_SERVICE_PROXY (remote_login_service_proxy_get_type ())
typedef GDBusProxy RemoteLoginServiceProxy;
typedef GDBusProxyClass RemoteLoginServiceProxyClass;

struct _RemoteServerField {
	gchar* type;
	gboolean required;
	GVariant* default_value;
	GHashTable* properties;
};

struct _RemoteServerApplication {
	gchar* application_id;
	gint pin_position;
};

struct _RemoteServer {
	gchar* type;
	gchar* name;
	gchar* url;
	gboolean last_used_server;
	RemoteServerField* fields;
	gint fields_length1;
	RemoteServerApplication* applications;
	gint applications_length1;
};

struct _RemoteLoginServiceIface {
	GTypeInterface parent_iface;
	void (*get_servers) (RemoteLoginService* self, GAsyncReadyCallback _callback_, gpointer _user_data_);
	void (*get_servers_finish) (RemoteLoginService* self, GAsyncResult* _res_, RemoteServer** serverList, int* serverList_length1, GError** error);
	void (*get_servers_for_login) (RemoteLoginService* self, const gchar* url, const gchar* emailAddress, const gchar* password, gboolean allowCache, GAsyncReadyCallback _callback_, gpointer _user_data_);
	void (*get_servers_for_login_finish) (RemoteLoginService* self, GAsyncResult* _res_, gboolean* loginSuccess, gchar** dataType, RemoteServer** serverList, int* serverList_length1, GError** error);
	void (*get_cached_domains_for_server) (RemoteLoginService* self, const gchar* url, GAsyncReadyCallback _callback_, gpointer _user_data_);
	void (*get_cached_domains_for_server_finish) (RemoteLoginService* self, GAsyncResult* _res_, gchar*** domains, int* domains_length1, GError** error);
	void (*set_last_used_server) (RemoteLoginService* self, const gchar* uccsUrl, const gchar* serverUrl, GAsyncReadyCallback _callback_, gpointer _user_data_);
	void (*set_last_used_server_finish) (RemoteLoginService* self, GAsyncResult* _res_, GError** error);
};



GType remote_server_field_get_type (void) G_GNUC_CONST;
RemoteServerField* remote_server_field_dup (const RemoteServerField* self);
void remote_server_field_free (RemoteServerField* self);
void remote_server_field_copy (const RemoteServerField* self, RemoteServerField* dest);
void remote_server_field_destroy (RemoteServerField* self);
GType remote_server_application_get_type (void) G_GNUC_CONST;
RemoteServerApplication* remote_server_application_dup (const RemoteServerApplication* self);
void remote_server_application_free (RemoteServerApplication* self);
void remote_server_application_copy (const RemoteServerApplication* self, RemoteServerApplication* dest);
void remote_server_application_destroy (RemoteServerApplication* self);
GType remote_server_get_type (void) G_GNUC_CONST;
RemoteServer* remote_server_dup (const RemoteServer* self);
void remote_server_free (RemoteServer* self);
void remote_server_copy (const RemoteServer* self, RemoteServer* dest);
void remote_server_destroy (RemoteServer* self);
static void _vala_RemoteServerField_array_free (RemoteServerField* array, gint array_length);
static void _vala_RemoteServerApplication_array_free (RemoteServerApplication* array, gint array_length);
static RemoteServerField* _vala_array_dup4 (RemoteServerField* self, int length);
static RemoteServerApplication* _vala_array_dup5 (RemoteServerApplication* self, int length);
GType remote_login_service_proxy_get_type (void) G_GNUC_CONST;
guint remote_login_service_register_object (void* object, GDBusConnection* connection, const gchar* path, GError** error);
GType remote_login_service_get_type (void) G_GNUC_CONST;
void remote_login_service_get_servers (RemoteLoginService* self, GAsyncReadyCallback _callback_, gpointer _user_data_);
void remote_login_service_get_servers_finish (RemoteLoginService* self, GAsyncResult* _res_, RemoteServer** serverList, int* serverList_length1, GError** error);
void remote_login_service_get_servers_for_login (RemoteLoginService* self, const gchar* url, const gchar* emailAddress, const gchar* password, gboolean allowCache, GAsyncReadyCallback _callback_, gpointer _user_data_);
void remote_login_service_get_servers_for_login_finish (RemoteLoginService* self, GAsyncResult* _res_, gboolean* loginSuccess, gchar** dataType, RemoteServer** serverList, int* serverList_length1, GError** error);
void remote_login_service_get_cached_domains_for_server (RemoteLoginService* self, const gchar* url, GAsyncReadyCallback _callback_, gpointer _user_data_);
void remote_login_service_get_cached_domains_for_server_finish (RemoteLoginService* self, GAsyncResult* _res_, gchar*** domains, int* domains_length1, GError** error);
void remote_login_service_set_last_used_server (RemoteLoginService* self, const gchar* uccsUrl, const gchar* serverUrl, GAsyncReadyCallback _callback_, gpointer _user_data_);
void remote_login_service_set_last_used_server_finish (RemoteLoginService* self, GAsyncResult* _res_, GError** error);
static void g_cclosure_user_marshal_VOID__POINTER_INT (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data);
static void g_cclosure_user_marshal_VOID__STRING_STRING_STRING_POINTER_INT (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data);
static void g_cclosure_user_marshal_VOID__STRING_STRING (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data);
static void remote_login_service_proxy_g_signal (GDBusProxy* proxy, const gchar* sender_name, const gchar* signal_name, GVariant* parameters);
static void _vala_RemoteServer_array_free (RemoteServer* array, gint array_length);
static void _dbus_handle_remote_login_service_servers_updated (RemoteLoginService* self, GVariant* parameters);
static void _dbus_handle_remote_login_service_login_servers_updated (RemoteLoginService* self, GVariant* parameters);
static void _dbus_handle_remote_login_service_login_changed (RemoteLoginService* self, GVariant* parameters);
static void _vala_g_async_ready_callback (GObject *source_object, GAsyncResult *res, void *user_data);
static void remote_login_service_proxy_get_servers_async (RemoteLoginService* self, GAsyncReadyCallback _callback_, gpointer _user_data_);
static void remote_login_service_proxy_get_servers_finish (RemoteLoginService* self, GAsyncResult* _res_, RemoteServer** serverList, int* serverList_length1, GError** error);
static void remote_login_service_proxy_get_servers_for_login_async (RemoteLoginService* self, const gchar* url, const gchar* emailAddress, const gchar* password, gboolean allowCache, GAsyncReadyCallback _callback_, gpointer _user_data_);
static void remote_login_service_proxy_get_servers_for_login_finish (RemoteLoginService* self, GAsyncResult* _res_, gboolean* loginSuccess, gchar** dataType, RemoteServer** serverList, int* serverList_length1, GError** error);
static void remote_login_service_proxy_get_cached_domains_for_server_async (RemoteLoginService* self, const gchar* url, GAsyncReadyCallback _callback_, gpointer _user_data_);
static void remote_login_service_proxy_get_cached_domains_for_server_finish (RemoteLoginService* self, GAsyncResult* _res_, gchar*** domains, int* domains_length1, GError** error);
static void remote_login_service_proxy_set_last_used_server_async (RemoteLoginService* self, const gchar* uccsUrl, const gchar* serverUrl, GAsyncReadyCallback _callback_, gpointer _user_data_);
static void remote_login_service_proxy_set_last_used_server_finish (RemoteLoginService* self, GAsyncResult* _res_, GError** error);
static void remote_login_service_proxy_remote_login_service_interface_init (RemoteLoginServiceIface* iface);
static void _dbus_remote_login_service_get_servers (RemoteLoginService* self, GVariant* _parameters_, GDBusMethodInvocation* invocation);
static void _dbus_remote_login_service_get_servers_ready (GObject * source_object, GAsyncResult * _res_, gpointer _user_data_);
static void _dbus_remote_login_service_get_servers_for_login (RemoteLoginService* self, GVariant* _parameters_, GDBusMethodInvocation* invocation);
static void _dbus_remote_login_service_get_servers_for_login_ready (GObject * source_object, GAsyncResult * _res_, gpointer _user_data_);
static void _dbus_remote_login_service_get_cached_domains_for_server (RemoteLoginService* self, GVariant* _parameters_, GDBusMethodInvocation* invocation);
static void _dbus_remote_login_service_get_cached_domains_for_server_ready (GObject * source_object, GAsyncResult * _res_, gpointer _user_data_);
static void _dbus_remote_login_service_set_last_used_server (RemoteLoginService* self, GVariant* _parameters_, GDBusMethodInvocation* invocation);
static void _dbus_remote_login_service_set_last_used_server_ready (GObject * source_object, GAsyncResult * _res_, gpointer _user_data_);
static void remote_login_service_dbus_interface_method_call (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* method_name, GVariant* parameters, GDBusMethodInvocation* invocation, gpointer user_data);
static GVariant* remote_login_service_dbus_interface_get_property (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* property_name, GError** error, gpointer user_data);
static gboolean remote_login_service_dbus_interface_set_property (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* property_name, GVariant* value, GError** error, gpointer user_data);
static void _dbus_remote_login_service_servers_updated (GObject* _sender, RemoteServer* serverList, int serverList_length1, gpointer* _data);
static void _dbus_remote_login_service_login_servers_updated (GObject* _sender, const gchar* url, const gchar* emailAddress, const gchar* dataType, RemoteServer* serverList, int serverList_length1, gpointer* _data);
static void _dbus_remote_login_service_login_changed (GObject* _sender, const gchar* url, const gchar* emailAddress, gpointer* _data);
static void _remote_login_service_unregister_object (gpointer user_data);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);

static const GDBusArgInfo _remote_login_service_dbus_arg_info_get_servers_serverList = {-1, "serverList", "a(sssba(sbva{sv})a(si))"};
static const GDBusArgInfo * const _remote_login_service_dbus_arg_info_get_servers_in[] = {NULL};
static const GDBusArgInfo * const _remote_login_service_dbus_arg_info_get_servers_out[] = {&_remote_login_service_dbus_arg_info_get_servers_serverList, NULL};
static const GDBusMethodInfo _remote_login_service_dbus_method_info_get_servers = {-1, "GetServers", (GDBusArgInfo **) (&_remote_login_service_dbus_arg_info_get_servers_in), (GDBusArgInfo **) (&_remote_login_service_dbus_arg_info_get_servers_out)};
static const GDBusArgInfo _remote_login_service_dbus_arg_info_get_servers_for_login_url = {-1, "url", "s"};
static const GDBusArgInfo _remote_login_service_dbus_arg_info_get_servers_for_login_emailAddress = {-1, "emailAddress", "s"};
static const GDBusArgInfo _remote_login_service_dbus_arg_info_get_servers_for_login_password = {-1, "password", "s"};
static const GDBusArgInfo _remote_login_service_dbus_arg_info_get_servers_for_login_allowCache = {-1, "allowCache", "b"};
static const GDBusArgInfo _remote_login_service_dbus_arg_info_get_servers_for_login_loginSuccess = {-1, "loginSuccess", "b"};
static const GDBusArgInfo _remote_login_service_dbus_arg_info_get_servers_for_login_dataType = {-1, "dataType", "s"};
static const GDBusArgInfo _remote_login_service_dbus_arg_info_get_servers_for_login_serverList = {-1, "serverList", "a(sssba(sbva{sv})a(si))"};
static const GDBusArgInfo * const _remote_login_service_dbus_arg_info_get_servers_for_login_in[] = {&_remote_login_service_dbus_arg_info_get_servers_for_login_url, &_remote_login_service_dbus_arg_info_get_servers_for_login_emailAddress, &_remote_login_service_dbus_arg_info_get_servers_for_login_password, &_remote_login_service_dbus_arg_info_get_servers_for_login_allowCache, NULL};
static const GDBusArgInfo * const _remote_login_service_dbus_arg_info_get_servers_for_login_out[] = {&_remote_login_service_dbus_arg_info_get_servers_for_login_loginSuccess, &_remote_login_service_dbus_arg_info_get_servers_for_login_dataType, &_remote_login_service_dbus_arg_info_get_servers_for_login_serverList, NULL};
static const GDBusMethodInfo _remote_login_service_dbus_method_info_get_servers_for_login = {-1, "GetServersForLogin", (GDBusArgInfo **) (&_remote_login_service_dbus_arg_info_get_servers_for_login_in), (GDBusArgInfo **) (&_remote_login_service_dbus_arg_info_get_servers_for_login_out)};
static const GDBusArgInfo _remote_login_service_dbus_arg_info_get_cached_domains_for_server_url = {-1, "url", "s"};
static const GDBusArgInfo _remote_login_service_dbus_arg_info_get_cached_domains_for_server_domains = {-1, "domains", "as"};
static const GDBusArgInfo * const _remote_login_service_dbus_arg_info_get_cached_domains_for_server_in[] = {&_remote_login_service_dbus_arg_info_get_cached_domains_for_server_url, NULL};
static const GDBusArgInfo * const _remote_login_service_dbus_arg_info_get_cached_domains_for_server_out[] = {&_remote_login_service_dbus_arg_info_get_cached_domains_for_server_domains, NULL};
static const GDBusMethodInfo _remote_login_service_dbus_method_info_get_cached_domains_for_server = {-1, "GetCachedDomainsForServer", (GDBusArgInfo **) (&_remote_login_service_dbus_arg_info_get_cached_domains_for_server_in), (GDBusArgInfo **) (&_remote_login_service_dbus_arg_info_get_cached_domains_for_server_out)};
static const GDBusArgInfo _remote_login_service_dbus_arg_info_set_last_used_server_uccsUrl = {-1, "uccsUrl", "s"};
static const GDBusArgInfo _remote_login_service_dbus_arg_info_set_last_used_server_serverUrl = {-1, "serverUrl", "s"};
static const GDBusArgInfo * const _remote_login_service_dbus_arg_info_set_last_used_server_in[] = {&_remote_login_service_dbus_arg_info_set_last_used_server_uccsUrl, &_remote_login_service_dbus_arg_info_set_last_used_server_serverUrl, NULL};
static const GDBusArgInfo * const _remote_login_service_dbus_arg_info_set_last_used_server_out[] = {NULL};
static const GDBusMethodInfo _remote_login_service_dbus_method_info_set_last_used_server = {-1, "SetLastUsedServer", (GDBusArgInfo **) (&_remote_login_service_dbus_arg_info_set_last_used_server_in), (GDBusArgInfo **) (&_remote_login_service_dbus_arg_info_set_last_used_server_out)};
static const GDBusMethodInfo * const _remote_login_service_dbus_method_info[] = {&_remote_login_service_dbus_method_info_get_servers, &_remote_login_service_dbus_method_info_get_servers_for_login, &_remote_login_service_dbus_method_info_get_cached_domains_for_server, &_remote_login_service_dbus_method_info_set_last_used_server, NULL};
static const GDBusArgInfo _remote_login_service_dbus_arg_info_servers_updated_serverList = {-1, "serverList", "a(sssba(sbva{sv})a(si))"};
static const GDBusArgInfo * const _remote_login_service_dbus_arg_info_servers_updated[] = {&_remote_login_service_dbus_arg_info_servers_updated_serverList, NULL};
static const GDBusSignalInfo _remote_login_service_dbus_signal_info_servers_updated = {-1, "ServersUpdated", (GDBusArgInfo **) (&_remote_login_service_dbus_arg_info_servers_updated)};
static const GDBusArgInfo _remote_login_service_dbus_arg_info_login_servers_updated_url = {-1, "url", "s"};
static const GDBusArgInfo _remote_login_service_dbus_arg_info_login_servers_updated_emailAddress = {-1, "emailAddress", "s"};
static const GDBusArgInfo _remote_login_service_dbus_arg_info_login_servers_updated_dataType = {-1, "dataType", "s"};
static const GDBusArgInfo _remote_login_service_dbus_arg_info_login_servers_updated_serverList = {-1, "serverList", "a(sssba(sbva{sv})a(si))"};
static const GDBusArgInfo * const _remote_login_service_dbus_arg_info_login_servers_updated[] = {&_remote_login_service_dbus_arg_info_login_servers_updated_url, &_remote_login_service_dbus_arg_info_login_servers_updated_emailAddress, &_remote_login_service_dbus_arg_info_login_servers_updated_dataType, &_remote_login_service_dbus_arg_info_login_servers_updated_serverList, NULL};
static const GDBusSignalInfo _remote_login_service_dbus_signal_info_login_servers_updated = {-1, "LoginServersUpdated", (GDBusArgInfo **) (&_remote_login_service_dbus_arg_info_login_servers_updated)};
static const GDBusArgInfo _remote_login_service_dbus_arg_info_login_changed_url = {-1, "url", "s"};
static const GDBusArgInfo _remote_login_service_dbus_arg_info_login_changed_emailAddress = {-1, "emailAddress", "s"};
static const GDBusArgInfo * const _remote_login_service_dbus_arg_info_login_changed[] = {&_remote_login_service_dbus_arg_info_login_changed_url, &_remote_login_service_dbus_arg_info_login_changed_emailAddress, NULL};
static const GDBusSignalInfo _remote_login_service_dbus_signal_info_login_changed = {-1, "LoginChanged", (GDBusArgInfo **) (&_remote_login_service_dbus_arg_info_login_changed)};
static const GDBusSignalInfo * const _remote_login_service_dbus_signal_info[] = {&_remote_login_service_dbus_signal_info_servers_updated, &_remote_login_service_dbus_signal_info_login_servers_updated, &_remote_login_service_dbus_signal_info_login_changed, NULL};
static const GDBusPropertyInfo * const _remote_login_service_dbus_property_info[] = {NULL};
static const GDBusInterfaceInfo _remote_login_service_dbus_interface_info = {-1, "com.canonical.RemoteLogin", (GDBusMethodInfo **) (&_remote_login_service_dbus_method_info), (GDBusSignalInfo **) (&_remote_login_service_dbus_signal_info), (GDBusPropertyInfo **) (&_remote_login_service_dbus_property_info)};
static const GDBusInterfaceVTable _remote_login_service_dbus_interface_vtable = {remote_login_service_dbus_interface_method_call, remote_login_service_dbus_interface_get_property, remote_login_service_dbus_interface_set_property};

static gpointer _g_variant_ref0 (gpointer self) {
#line 19 "/home/abuild/rpmbuild/BUILD/slick-greeter-1.0.8/src/remote-login-service.vala"
	return self ? g_variant_ref (self) : NULL;
#line 203 "remote-login-service.c"
}


static gpointer _g_hash_table_ref0 (gpointer self) {
#line 19 "/home/abuild/rpmbuild/BUILD/slick-greeter-1.0.8/src/remote-login-service.vala"
	return self ? g_hash_table_ref (self) : NULL;
#line 210 "remote-login-service.c"
}


void remote_server_field_copy (const RemoteServerField* self, RemoteServerField* dest) {
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	gboolean _tmp2_ = FALSE;
	GVariant* _tmp3_ = NULL;
	GVariant* _tmp4_ = NULL;
	GHashTable* _tmp5_ = NULL;
	GHashTable* _tmp6_ = NULL;
#line 19 "/home/abuild/rpmbuild/BUILD/slick-greeter-1.0.8/src/remote-login-service.vala"
	_tmp0_ = (*self).type;
#line 19 "/home/abuild/rpmbuild/BUILD/slick-greeter-1.0.8/src/remote-login-service.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 19 "/home/abuild/rpmbuild/BUILD/slick-greeter-1.0.8/src/remote-login-service.vala"
	_g_free0 ((*dest).type);
#line 19 "/home/abuild/rpmbuild/BUILD/slick-greeter-1.0.8/src/remote-login-service.vala"
	(*dest).type = _tmp1_;
#line 19 "/home/abuild/rpmbuild/BUILD/slick-greeter-1.0.8/src/remote-login-service.vala"
	_tmp2_ = (*self).required;
#line 19 "/home/abuild/rpmbuild/BUILD/slick-greeter-1.0.8/src/remote-login-service.vala"
	(*dest).required = _tmp2_;
#line 19 "/home/abuild/rpmbuild/BUILD/slick-greeter-1.0.8/src/remote-login-service.vala"
	_tmp3_ = (*self).default_value;
#line 19 "/home/abuild/rpmbuild/BUILD/slick-greeter-1.0.8/src/remote-login-service.vala"
	_tmp4_ = _g_variant_ref0 (_tmp3_);
#line 19 "/home/abuild/rpmbuild/BUILD/slick-greeter-1.0.8/src/remote-login-service.vala"
	_g_variant_unref0 ((*dest).default_value);
#line 19 "/home/abuild/rpmbuild/BUILD/slick-greeter-1.0.8/src/remote-login-service.vala"
	(*dest).default_value = _tmp4_;
#line 19 "/home/abuild/rpmbuild/BUILD/slick-greeter-1.0.8/src/remote-login-service.vala"
	_tmp5_ = (*self).properties;
#line 19 "/home/abuild/rpmbuild/BUILD/slick-greeter-1.0.8/src/remote-login-service.vala"
	_tmp6_ = _g_hash_table_ref0 (_tmp5_);
#line 19 "/home/abuild/rpmbuild/BUILD/slick-greeter-1.0.8/src/remote-login-service.vala"
	_g_hash_table_unref0 ((*dest).properties);
#line 19 "/home/abuild/rpmbuild/BUILD/slick-greeter-1.0.8/src/remote-login-service.vala"
	(*dest).properties = _tmp6_;
#line 250 "remote-login-service.c"
}


void remote_server_field_destroy (RemoteServerField* self) {
#line 21 "/home/abuild/rpmbuild/BUILD/slick-greeter-1.0.8/src/remote-login-service.vala"
	_g_free0 ((*self).type);
#line 23 "/home/abuild/rpmbuild/BUILD/slick-greeter-1.0.8/src/remote-login-service.vala"
	_g_variant_unref0 ((*self).default_value);
#line 24 "/home/abuild/rpmbuild/BUILD/slick-greeter-1.0.8/src/remote-login-service.vala"
	_g_hash_table_unref0 ((*self).properties);
#line 261 "remote-login-service.c"
}


RemoteServerField* remote_server_field_dup (const RemoteServerField* self) {
	RemoteServerField* dup;
#line 19 "/home/abuild/rpmbuild/BUILD/slick-greeter-1.0.8/src/remote-login-service.vala"
	dup = g_new0 (RemoteServerField, 1);
#line 19 "/home/abuild/rpmbuild/BUILD/slick-greeter-1.0.8/src/remote-login-service.vala"
	remote_server_field_copy (self, dup);
#line 19 "/home/abuild/rpmbuild/BUILD/slick-greeter-1.0.8/src/remote-login-service.vala"
	return dup;
#line 273 "remote-login-service.c"
}


void remote_server_field_free (RemoteServerField* self) {
#line 19 "/home/abuild/rpmbuild/BUILD/slick-greeter-1.0.8/src/remote-login-service.vala"
	remote_server_field_destroy (self);
#line 19 "/home/abuild/rpmbuild/BUILD/slick-greeter-1.0.8/src/remote-login-service.vala"
	g_free (self);
#line 282 "remote-login-service.c"
}


GType remote_server_field_get_type (void) {
	static volatile gsize remote_server_field_type_id__volatile = 0;
	if (g_once_init_enter (&remote_server_field_type_id__volatile)) {
		GType remote_server_field_type_id;
		remote_server_field_type_id = g_boxed_type_register_static ("RemoteServerField", (GBoxedCopyFunc) remote_server_field_dup, (GBoxedFreeFunc) remote_server_field_free);
		g_once_init_leave (&remote_server_field_type_id__volatile, remote_server_field_type_id);
	}
	return remote_server_field_type_id__volatile;
}


void remote_server_application_copy (const RemoteServerApplication* self, RemoteServerApplication* dest) {
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	gint _tmp2_ = 0;
#line 27 "/home/abuild/rpmbuild/BUILD/slick-greeter-1.0.8/src/remote-login-service.vala"
	_tmp0_ = (*self).application_id;
#line 27 "/home/abuild/rpmbuild/BUILD/slick-greeter-1.0.8/src/remote-login-service.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 27 "/home/abuild/rpmbuild/BUILD/slick-greeter-1.0.8/src/remote-login-service.vala"
	_g_free0 ((*dest).application_id);
#line 27 "/home/abuild/rpmbuild/BUILD/slick-greeter-1.0.8/src/remote-login-service.vala"
	(*dest).application_id = _tmp1_;
#line 27 "/home/abuild/rpmbuild/BUILD/slick-greeter-1.0.8/src/remote-login-service.vala"
	_tmp2_ = (*self).pin_position;
#line 27 "/home/abuild/rpmbuild/BUILD/slick-greeter-1.0.8/src/remote-login-service.vala"
	(*dest).pin_position = _tmp2_;
#line 313 "remote-login-service.c"
}


void remote_server_application_destroy (RemoteServerApplication* self) {
#line 29 "/home/abuild/rpmbuild/BUILD/slick-greeter-1.0.8/src/remote-login-service.vala"
	_g_free0 ((*self).application_id);
#line 320 "remote-login-service.c"
}


RemoteServerApplication* remote_server_application_dup (const RemoteServerApplication* self) {
	RemoteServerApplication* dup;
#line 27 "/home/abuild/rpmbuild/BUILD/slick-greeter-1.0.8/src/remote-login-service.vala"
	dup = g_new0 (RemoteServerApplication, 1);
#line 27 "/home/abuild/rpmbuild/BUILD/slick-greeter-1.0.8/src/remote-login-service.vala"
	remote_server_application_copy (self, dup);
#line 27 "/home/abuild/rpmbuild/BUILD/slick-greeter-1.0.8/src/remote-login-service.vala"
	return dup;
#line 332 "remote-login-service.c"
}


void remote_server_application_free (RemoteServerApplication* self) {
#line 27 "/home/abuild/rpmbuild/BUILD/slick-greeter-1.0.8/src/remote-login-service.vala"
	remote_server_application_destroy (self);
#line 27 "/home/abuild/rpmbuild/BUILD/slick-greeter-1.0.8/src/remote-login-service.vala"
	g_free (self);
#line 341 "remote-login-service.c"
}


GType remote_server_application_get_type (void) {
	static volatile gsize remote_server_application_type_id__volatile = 0;
	if (g_once_init_enter (&remote_server_application_type_id__volatile)) {
		GType remote_server_application_type_id;
		remote_server_application_type_id = g_boxed_type_register_static ("RemoteServerApplication", (GBoxedCopyFunc) remote_server_application_dup, (GBoxedFreeFunc) remote_server_application_free);
		g_once_init_leave (&remote_server_application_type_id__volatile, remote_server_application_type_id);
	}
	return remote_server_application_type_id__volatile;
}


static void _vala_RemoteServerField_array_free (RemoteServerField* array, gint array_length) {
#line 39 "/home/abuild/rpmbuild/BUILD/slick-greeter-1.0.8/src/remote-login-service.vala"
	if (array != NULL) {
#line 359 "remote-login-service.c"
		int i;
#line 39 "/home/abuild/rpmbuild/BUILD/slick-greeter-1.0.8/src/remote-login-service.vala"
		for (i = 0; i < array_length; i = i + 1) {
#line 39 "/home/abuild/rpmbuild/BUILD/slick-greeter-1.0.8/src/remote-login-service.vala"
			remote_server_field_destroy (&array[i]);
#line 365 "remote-login-service.c"
		}
	}
#line 39 "/home/abuild/rpmbuild/BUILD/slick-greeter-1.0.8/src/remote-login-service.vala"
	g_free (array);
#line 370 "remote-login-service.c"
}


static void _vala_RemoteServerApplication_array_free (RemoteServerApplication* array, gint array_length) {
#line 40 "/home/abuild/rpmbuild/BUILD/slick-greeter-1.0.8/src/remote-login-service.vala"
	if (array != NULL) {
#line 377 "remote-login-service.c"
		int i;
#line 40 "/home/abuild/rpmbuild/BUILD/slick-greeter-1.0.8/src/remote-login-service.vala"
		for (i = 0; i < array_length; i = i + 1) {
#line 40 "/home/abuild/rpmbuild/BUILD/slick-greeter-1.0.8/src/remote-login-service.vala"
			remote_server_application_destroy (&array[i]);
#line 383 "remote-login-service.c"
		}
	}
#line 40 "/home/abuild/rpmbuild/BUILD/slick-greeter-1.0.8/src/remote-login-service.vala"
	g_free (array);
#line 388 "remote-login-service.c"
}


static RemoteServerField* _vala_array_dup4 (RemoteServerField* self, int length) {
	RemoteServerField* result;
	int i;
#line 33 "/home/abuild/rpmbuild/BUILD/slick-greeter-1.0.8/src/remote-login-service.vala"
	result = g_new0 (RemoteServerField, length);
#line 33 "/home/abuild/rpmbuild/BUILD/slick-greeter-1.0.8/src/remote-login-service.vala"
	for (i = 0; i < length; i++) {
#line 399 "remote-login-service.c"
		RemoteServerField _tmp0_ = {0};
#line 33 "/home/abuild/rpmbuild/BUILD/slick-greeter-1.0.8/src/remote-login-service.vala"
		remote_server_field_copy (&self[i], &_tmp0_);
#line 33 "/home/abuild/rpmbuild/BUILD/slick-greeter-1.0.8/src/remote-login-service.vala"
		result[i] = _tmp0_;
#line 405 "remote-login-service.c"
	}
#line 33 "/home/abuild/rpmbuild/BUILD/slick-greeter-1.0.8/src/remote-login-service.vala"
	return result;
#line 409 "remote-login-service.c"
}


static RemoteServerApplication* _vala_array_dup5 (RemoteServerApplication* self, int length) {
	RemoteServerApplication* result;
	int i;
#line 33 "/home/abuild/rpmbuild/BUILD/slick-greeter-1.0.8/src/remote-login-service.vala"
	result = g_new0 (RemoteServerApplication, length);
#line 33 "/home/abuild/rpmbuild/BUILD/slick-greeter-1.0.8/src/remote-login-service.vala"
	for (i = 0; i < length; i++) {
#line 420 "remote-login-service.c"
		RemoteServerApplication _tmp0_ = {0};
#line 33 "/home/abuild/rpmbuild/BUILD/slick-greeter-1.0.8/src/remote-login-service.vala"
		remote_server_application_copy (&self[i], &_tmp0_);
#line 33 "/home/abuild/rpmbuild/BUILD/slick-greeter-1.0.8/src/remote-login-service.vala"
		result[i] = _tmp0_;
#line 426 "remote-login-service.c"
	}
#line 33 "/home/abuild/rpmbuild/BUILD/slick-greeter-1.0.8/src/remote-login-service.vala"
	return result;
#line 430 "remote-login-service.c"
}


void remote_server_copy (const RemoteServer* self, RemoteServer* dest) {
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	const gchar* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
	const gchar* _tmp4_ = NULL;
	gchar* _tmp5_ = NULL;
	gboolean _tmp6_ = FALSE;
	RemoteServerField* _tmp7_ = NULL;
	gint _tmp7__length1 = 0;
	RemoteServerField* _tmp8_ = NULL;
	gint _tmp8__length1 = 0;
	RemoteServerApplication* _tmp9_ = NULL;
	gint _tmp9__length1 = 0;
	RemoteServerApplication* _tmp10_ = NULL;
	gint _tmp10__length1 = 0;
#line 33 "/home/abuild/rpmbuild/BUILD/slick-greeter-1.0.8/src/remote-login-service.vala"
	_tmp0_ = (*self).type;
#line 33 "/home/abuild/rpmbuild/BUILD/slick-greeter-1.0.8/src/remote-login-service.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 33 "/home/abuild/rpmbuild/BUILD/slick-greeter-1.0.8/src/remote-login-service.vala"
	_g_free0 ((*dest).type);
#line 33 "/home/abuild/rpmbuild/BUILD/slick-greeter-1.0.8/src/remote-login-service.vala"
	(*dest).type = _tmp1_;
#line 33 "/home/abuild/rpmbuild/BUILD/slick-greeter-1.0.8/src/remote-login-service.vala"
	_tmp2_ = (*self).name;
#line 33 "/home/abuild/rpmbuild/BUILD/slick-greeter-1.0.8/src/remote-login-service.vala"
	_tmp3_ = g_strdup (_tmp2_);
#line 33 "/home/abuild/rpmbuild/BUILD/slick-greeter-1.0.8/src/remote-login-service.vala"
	_g_free0 ((*dest).name);
#line 33 "/home/abuild/rpmbuild/BUILD/slick-greeter-1.0.8/src/remote-login-service.vala"
	(*dest).name = _tmp3_;
#line 33 "/home/abuild/rpmbuild/BUILD/slick-greeter-1.0.8/src/remote-login-service.vala"
	_tmp4_ = (*self).url;
#line 33 "/home/abuild/rpmbuild/BUILD/slick-greeter-1.0.8/src/remote-login-service.vala"
	_tmp5_ = g_strdup (_tmp4_);
#line 33 "/home/abuild/rpmbuild/BUILD/slick-greeter-1.0.8/src/remote-login-service.vala"
	_g_free0 ((*dest).url);
#line 33 "/home/abuild/rpmbuild/BUILD/slick-greeter-1.0.8/src/remote-login-service.vala"
	(*dest).url = _tmp5_;
#line 33 "/home/abuild/rpmbuild/BUILD/slick-greeter-1.0.8/src/remote-login-service.vala"
	_tmp6_ = (*self).last_used_server;
#line 33 "/home/abuild/rpmbuild/BUILD/slick-greeter-1.0.8/src/remote-login-service.vala"
	(*dest).last_used_server = _tmp6_;
#line 33 "/home/abuild/rpmbuild/BUILD/slick-greeter-1.0.8/src/remote-login-service.vala"
	_tmp7_ = (*self).fields;
#line 33 "/home/abuild/rpmbuild/BUILD/slick-greeter-1.0.8/src/remote-login-service.vala"
	_tmp7__length1 = (*self).fields_length1;
#line 33 "/home/abuild/rpmbuild/BUILD/slick-greeter-1.0.8/src/remote-login-service.vala"
	_tmp8_ = (_tmp7_ != NULL) ? _vala_array_dup4 (_tmp7_, _tmp7__length1) : ((gpointer) _tmp7_);
#line 33 "/home/abuild/rpmbuild/BUILD/slick-greeter-1.0.8/src/remote-login-service.vala"
	_tmp8__length1 = _tmp7__length1;
#line 33 "/home/abuild/rpmbuild/BUILD/slick-greeter-1.0.8/src/remote-login-service.vala"
	(*dest).fields = (_vala_RemoteServerField_array_free ((*dest).fields, (*dest).fields_length1), NULL);
#line 33 "/home/abuild/rpmbuild/BUILD/slick-greeter-1.0.8/src/remote-login-service.vala"
	(*dest).fields = _tmp8_;
#line 33 "/home/abuild/rpmbuild/BUILD/slick-greeter-1.0.8/src/remote-login-service.vala"
	(*dest).fields_length1 = _tmp8__length1;
#line 33 "/home/abuild/rpmbuild/BUILD/slick-greeter-1.0.8/src/remote-login-service.vala"
	_tmp9_ = (*self).applications;
#line 33 "/home/abuild/rpmbuild/BUILD/slick-greeter-1.0.8/src/remote-login-service.vala"
	_tmp9__length1 = (*self).applications_length1;
#line 33 "/home/abuild/rpmbuild/BUILD/slick-greeter-1.0.8/src/remote-login-service.vala"
	_tmp10_ = (_tmp9_ != NULL) ? _vala_array_dup5 (_tmp9_, _tmp9__length1) : ((gpointer) _tmp9_);
#line 33 "/home/abuild/rpmbuild/BUILD/slick-greeter-1.0.8/src/remote-login-service.vala"
	_tmp10__length1 = _tmp9__length1;
#line 33 "/home/abuild/rpmbuild/BUILD/slick-greeter-1.0.8/src/remote-login-service.vala"
	(*dest).applications = (_vala_RemoteServerApplication_array_free ((*dest).applications, (*dest).applications_length1), NULL);
#line 33 "/home/abuild/rpmbuild/BUILD/slick-greeter-1.0.8/src/remote-login-service.vala"
	(*dest).applications = _tmp10_;
#line 33 "/home/abuild/rpmbuild/BUILD/slick-greeter-1.0.8/src/remote-login-service.vala"
	(*dest).applications_length1 = _tmp10__length1;
#line 506 "remote-login-service.c"
}


void remote_server_destroy (RemoteServer* self) {
#line 35 "/home/abuild/rpmbuild/BUILD/slick-greeter-1.0.8/src/remote-login-service.vala"
	_g_free0 ((*self).type);
#line 36 "/home/abuild/rpmbuild/BUILD/slick-greeter-1.0.8/src/remote-login-service.vala"
	_g_free0 ((*self).name);
#line 37 "/home/abuild/rpmbuild/BUILD/slick-greeter-1.0.8/src/remote-login-service.vala"
	_g_free0 ((*self).url);
#line 39 "/home/abuild/rpmbuild/BUILD/slick-greeter-1.0.8/src/remote-login-service.vala"
	(*self).fields = (_vala_RemoteServerField_array_free ((*self).fields, (*self).fields_length1), NULL);
#line 40 "/home/abuild/rpmbuild/BUILD/slick-greeter-1.0.8/src/remote-login-service.vala"
	(*self).applications = (_vala_RemoteServerApplication_array_free ((*self).applications, (*self).applications_length1), NULL);
#line 521 "remote-login-service.c"
}


RemoteServer* remote_server_dup (const RemoteServer* self) {
	RemoteServer* dup;
#line 33 "/home/abuild/rpmbuild/BUILD/slick-greeter-1.0.8/src/remote-login-service.vala"
	dup = g_new0 (RemoteServer, 1);
#line 33 "/home/abuild/rpmbuild/BUILD/slick-greeter-1.0.8/src/remote-login-service.vala"
	remote_server_copy (self, dup);
#line 33 "/home/abuild/rpmbuild/BUILD/slick-greeter-1.0.8/src/remote-login-service.vala"
	return dup;
#line 533 "remote-login-service.c"
}


void remote_server_free (RemoteServer* self) {
#line 33 "/home/abuild/rpmbuild/BUILD/slick-greeter-1.0.8/src/remote-login-service.vala"
	remote_server_destroy (self);
#line 33 "/home/abuild/rpmbuild/BUILD/slick-greeter-1.0.8/src/remote-login-service.vala"
	g_free (self);
#line 542 "remote-login-service.c"
}


GType remote_server_get_type (void) {
	static volatile gsize remote_server_type_id__volatile = 0;
	if (g_once_init_enter (&remote_server_type_id__volatile)) {
		GType remote_server_type_id;
		remote_server_type_id = g_boxed_type_register_static ("RemoteServer", (GBoxedCopyFunc) remote_server_dup, (GBoxedFreeFunc) remote_server_free);
		g_once_init_leave (&remote_server_type_id__volatile, remote_server_type_id);
	}
	return remote_server_type_id__volatile;
}


void remote_login_service_get_servers (RemoteLoginService* self, GAsyncReadyCallback _callback_, gpointer _user_data_) {
#line 44 "/home/abuild/rpmbuild/BUILD/slick-greeter-1.0.8/src/remote-login-service.vala"
	REMOTE_LOGIN_SERVICE_GET_INTERFACE (self)->get_servers (self, _callback_, _user_data_);
#line 560 "remote-login-service.c"
}


void remote_login_service_get_servers_finish (RemoteLoginService* self, GAsyncResult* _res_, RemoteServer** serverList, int* serverList_length1, GError** error) {
#line 44 "/home/abuild/rpmbuild/BUILD/slick-greeter-1.0.8/src/remote-login-service.vala"
	REMOTE_LOGIN_SERVICE_GET_INTERFACE (self)->get_servers_finish (self, _res_, serverList, serverList_length1, error);
#line 567 "remote-login-service.c"
}


void remote_login_service_get_servers_for_login (RemoteLoginService* self, const gchar* url, const gchar* emailAddress, const gchar* password, gboolean allowCache, GAsyncReadyCallback _callback_, gpointer _user_data_) {
#line 44 "/home/abuild/rpmbuild/BUILD/slick-greeter-1.0.8/src/remote-login-service.vala"
	REMOTE_LOGIN_SERVICE_GET_INTERFACE (self)->get_servers_for_login (self, url, emailAddress, password, allowCache, _callback_, _user_data_);
#line 574 "remote-login-service.c"
}


void remote_login_service_get_servers_for_login_finish (RemoteLoginService* self, GAsyncResult* _res_, gboolean* loginSuccess, gchar** dataType, RemoteServer** serverList, int* serverList_length1, GError** error) {
#line 44 "/home/abuild/rpmbuild/BUILD/slick-greeter-1.0.8/src/remote-login-service.vala"
	REMOTE_LOGIN_SERVICE_GET_INTERFACE (self)->get_servers_for_login_finish (self, _res_, loginSuccess, dataType, serverList, serverList_length1, error);
#line 581 "remote-login-service.c"
}


void remote_login_service_get_cached_domains_for_server (RemoteLoginService* self, const gchar* url, GAsyncReadyCallback _callback_, gpointer _user_data_) {
#line 44 "/home/abuild/rpmbuild/BUILD/slick-greeter-1.0.8/src/remote-login-service.vala"
	REMOTE_LOGIN_SERVICE_GET_INTERFACE (self)->get_cached_domains_for_server (self, url, _callback_, _user_data_);
#line 588 "remote-login-service.c"
}


void remote_login_service_get_cached_domains_for_server_finish (RemoteLoginService* self, GAsyncResult* _res_, gchar*** domains, int* domains_length1, GError** error) {
#line 44 "/home/abuild/rpmbuild/BUILD/slick-greeter-1.0.8/src/remote-login-service.vala"
	REMOTE_LOGIN_SERVICE_GET_INTERFACE (self)->get_cached_domains_for_server_finish (self, _res_, domains, domains_length1, error);
#line 595 "remote-login-service.c"
}


void remote_login_service_set_last_used_server (RemoteLoginService* self, const gchar* uccsUrl, const gchar* serverUrl, GAsyncReadyCallback _callback_, gpointer _user_data_) {
#line 44 "/home/abuild/rpmbuild/BUILD/slick-greeter-1.0.8/src/remote-login-service.vala"
	REMOTE_LOGIN_SERVICE_GET_INTERFACE (self)->set_last_used_server (self, uccsUrl, serverUrl, _callback_, _user_data_);
#line 602 "remote-login-service.c"
}


void remote_login_service_set_last_used_server_finish (RemoteLoginService* self, GAsyncResult* _res_, GError** error) {
#line 44 "/home/abuild/rpmbuild/BUILD/slick-greeter-1.0.8/src/remote-login-service.vala"
	REMOTE_LOGIN_SERVICE_GET_INTERFACE (self)->set_last_used_server_finish (self, _res_, error);
#line 609 "remote-login-service.c"
}


static void g_cclosure_user_marshal_VOID__POINTER_INT (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data) {
	typedef void (*GMarshalFunc_VOID__POINTER_INT) (gpointer data1, gpointer arg_1, gint arg_2, gpointer data2);
	register GMarshalFunc_VOID__POINTER_INT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 44 "/home/abuild/rpmbuild/BUILD/slick-greeter-1.0.8/src/remote-login-service.vala"
	g_return_if_fail (n_param_values == 3);
#line 44 "/home/abuild/rpmbuild/BUILD/slick-greeter-1.0.8/src/remote-login-service.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 44 "/home/abuild/rpmbuild/BUILD/slick-greeter-1.0.8/src/remote-login-service.vala"
		data1 = closure->data;
#line 44 "/home/abuild/rpmbuild/BUILD/slick-greeter-1.0.8/src/remote-login-service.vala"
		data2 = param_values->data[0].v_pointer;
#line 628 "remote-login-service.c"
	} else {
#line 44 "/home/abuild/rpmbuild/BUILD/slick-greeter-1.0.8/src/remote-login-service.vala"
		data1 = param_values->data[0].v_pointer;
#line 44 "/home/abuild/rpmbuild/BUILD/slick-greeter-1.0.8/src/remote-login-service.vala"
		data2 = closure->data;
#line 634 "remote-login-service.c"
	}
#line 44 "/home/abuild/rpmbuild/BUILD/slick-greeter-1.0.8/src/remote-login-service.vala"
	callback = (GMarshalFunc_VOID__POINTER_INT) (marshal_data ? marshal_data : cc->callback);
#line 44 "/home/abuild/rpmbuild/BUILD/slick-greeter-1.0.8/src/remote-login-service.vala"
	callback (data1, g_value_get_pointer (param_values + 1), g_value_get_int (param_values + 2), data2);
#line 640 "remote-login-service.c"
}


static void g_cclosure_user_marshal_VOID__STRING_STRING_STRING_POINTER_INT (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data) {
	typedef void (*GMarshalFunc_VOID__STRING_STRING_STRING_POINTER_INT) (gpointer data1, const char* arg_1, const char* arg_2, const char* arg_3, gpointer arg_4, gint arg_5, gpointer data2);
	register GMarshalFunc_VOID__STRING_STRING_STRING_POINTER_INT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 44 "/home/abuild/rpmbuild/BUILD/slick-greeter-1.0.8/src/remote-login-service.vala"
	g_return_if_fail (n_param_values == 6);
#line 44 "/home/abuild/rpmbuild/BUILD/slick-greeter-1.0.8/src/remote-login-service.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 44 "/home/abuild/rpmbuild/BUILD/slick-greeter-1.0.8/src/remote-login-service.vala"
		data1 = closure->data;
#line 44 "/home/abuild/rpmbuild/BUILD/slick-greeter-1.0.8/src/remote-login-service.vala"
		data2 = param_values->data[0].v_pointer;
#line 659 "remote-login-service.c"
	} else {
#line 44 "/home/abuild/rpmbuild/BUILD/slick-greeter-1.0.8/src/remote-login-service.vala"
		data1 = param_values->data[0].v_pointer;
#line 44 "/home/abuild/rpmbuild/BUILD/slick-greeter-1.0.8/src/remote-login-service.vala"
		data2 = closure->data;
#line 665 "remote-login-service.c"
	}
#line 44 "/home/abuild/rpmbuild/BUILD/slick-greeter-1.0.8/src/remote-login-service.vala"
	callback = (GMarshalFunc_VOID__STRING_STRING_STRING_POINTER_INT) (marshal_data ? marshal_data : cc->callback);
#line 44 "/home/abuild/rpmbuild/BUILD/slick-greeter-1.0.8/src/remote-login-service.vala"
	callback (data1, g_value_get_string (param_values + 1), g_value_get_string (param_values + 2), g_value_get_string (param_values + 3), g_value_get_pointer (param_values + 4), g_value_get_int (param_values + 5), data2);
#line 671 "remote-login-service.c"
}


static void g_cclosure_user_marshal_VOID__STRING_STRING (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data) {
	typedef void (*GMarshalFunc_VOID__STRING_STRING) (gpointer data1, const char* arg_1, const char* arg_2, gpointer data2);
	register GMarshalFunc_VOID__STRING_STRING callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 44 "/home/abuild/rpmbuild/BUILD/slick-greeter-1.0.8/src/remote-login-service.vala"
	g_return_if_fail (n_param_values == 3);
#line 44 "/home/abuild/rpmbuild/BUILD/slick-greeter-1.0.8/src/remote-login-service.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 44 "/home/abuild/rpmbuild/BUILD/slick-greeter-1.0.8/src/remote-login-service.vala"
		data1 = closure->data;
#line 44 "/home/abuild/rpmbuild/BUILD/slick-greeter-1.0.8/src/remote-login-service.vala"
		data2 = param_values->data[0].v_pointer;
#line 690 "remote-login-service.c"
	} else {
#line 44 "/home/abuild/rpmbuild/BUILD/slick-greeter-1.0.8/src/remote-login-service.vala"
		data1 = param_values->data[0].v_pointer;
#line 44 "/home/abuild/rpmbuild/BUILD/slick-greeter-1.0.8/src/remote-login-service.vala"
		data2 = closure->data;
#line 696 "remote-login-service.c"
	}
#line 44 "/home/abuild/rpmbuild/BUILD/slick-greeter-1.0.8/src/remote-login-service.vala"
	callback = (GMarshalFunc_VOID__STRING_STRING) (marshal_data ? marshal_data : cc->callback);
#line 44 "/home/abuild/rpmbuild/BUILD/slick-greeter-1.0.8/src/remote-login-service.vala"
	callback (data1, g_value_get_string (param_values + 1), g_value_get_string (param_values + 2), data2);
#line 702 "remote-login-service.c"
}


static void remote_login_service_base_init (RemoteLoginServiceIface * iface) {
#line 44 "/home/abuild/rpmbuild/BUILD/slick-greeter-1.0.8/src/remote-login-service.vala"
	static gboolean initialized = FALSE;
#line 44 "/home/abuild/rpmbuild/BUILD/slick-greeter-1.0.8/src/remote-login-service.vala"
	if (!initialized) {
#line 44 "/home/abuild/rpmbuild/BUILD/slick-greeter-1.0.8/src/remote-login-service.vala"
		initialized = TRUE;
#line 44 "/home/abuild/rpmbuild/BUILD/slick-greeter-1.0.8/src/remote-login-service.vala"
		g_signal_new ("servers_updated", TYPE_REMOTE_LOGIN_SERVICE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__POINTER_INT, G_TYPE_NONE, 2, G_TYPE_POINTER, G_TYPE_INT);
#line 44 "/home/abuild/rpmbuild/BUILD/slick-greeter-1.0.8/src/remote-login-service.vala"
		g_signal_new ("login_servers_updated", TYPE_REMOTE_LOGIN_SERVICE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__STRING_STRING_STRING_POINTER_INT, G_TYPE_NONE, 5, G_TYPE_STRING, G_TYPE_STRING, G_TYPE_STRING, G_TYPE_POINTER, G_TYPE_INT);
#line 44 "/home/abuild/rpmbuild/BUILD/slick-greeter-1.0.8/src/remote-login-service.vala"
		g_signal_new ("login_changed", TYPE_REMOTE_LOGIN_SERVICE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__STRING_STRING, G_TYPE_NONE, 2, G_TYPE_STRING, G_TYPE_STRING);
#line 719 "remote-login-service.c"
	}
}


GType remote_login_service_get_type (void) {
	static volatile gsize remote_login_service_type_id__volatile = 0;
	if (g_once_init_enter (&remote_login_service_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (RemoteLoginServiceIface), (GBaseInitFunc) remote_login_service_base_init, (GBaseFinalizeFunc) NULL, (GClassInitFunc) NULL, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
		GType remote_login_service_type_id;
		remote_login_service_type_id = g_type_register_static (G_TYPE_INTERFACE, "RemoteLoginService", &g_define_type_info, 0);
		g_type_interface_add_prerequisite (remote_login_service_type_id, G_TYPE_OBJECT);
		g_type_set_qdata (remote_login_service_type_id, g_quark_from_static_string ("vala-dbus-proxy-type"), (void*) remote_login_service_proxy_get_type);
		g_type_set_qdata (remote_login_service_type_id, g_quark_from_static_string ("vala-dbus-interface-name"), "com.canonical.RemoteLogin");
		g_type_set_qdata (remote_login_service_type_id, g_quark_from_static_string ("vala-dbus-interface-info"), (void*) (&_remote_login_service_dbus_interface_info));
		g_type_set_qdata (remote_login_service_type_id, g_quark_from_static_string ("vala-dbus-register-object"), (void*) remote_login_service_register_object);
		g_once_init_leave (&remote_login_service_type_id__volatile, remote_login_service_type_id);
	}
	return remote_login_service_type_id__volatile;
}


G_DEFINE_TYPE_EXTENDED (RemoteLoginServiceProxy, remote_login_service_proxy, G_TYPE_DBUS_PROXY, 0, G_IMPLEMENT_INTERFACE (TYPE_REMOTE_LOGIN_SERVICE, remote_login_service_proxy_remote_login_service_interface_init) )
static void remote_login_service_proxy_class_init (RemoteLoginServiceProxyClass* klass) {
	G_DBUS_PROXY_CLASS (klass)->g_signal = remote_login_service_proxy_g_signal;
}


static void _vala_RemoteServer_array_free (RemoteServer* array, gint array_length) {
	if (array != NULL) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			remote_server_destroy (&array[i]);
		}
	}
	g_free (array);
}


static void _dbus_handle_remote_login_service_servers_updated (RemoteLoginService* self, GVariant* parameters) {
	GVariantIter _arguments_iter;
	RemoteServer* serverList = NULL;
	int serverList_length1;
	GVariant* _tmp11_;
	RemoteServer* _tmp12_;
	int _tmp12__length;
	int _tmp12__size;
	int _tmp12__length1;
	GVariantIter _tmp13_;
	GVariant* _tmp14_;
	g_variant_iter_init (&_arguments_iter, parameters);
	serverList_length1 = 0;
	_tmp11_ = g_variant_iter_next_value (&_arguments_iter);
	_tmp12_ = g_new (RemoteServer, 5);
	_tmp12__length = 0;
	_tmp12__size = 4;
	_tmp12__length1 = 0;
	g_variant_iter_init (&_tmp13_, _tmp11_);
	for (; (_tmp14_ = g_variant_iter_next_value (&_tmp13_)) != NULL; _tmp12__length1++) {
		RemoteServer _tmp15_;
		GVariantIter _tmp16_;
		GVariant* _tmp17_;
		GVariant* _tmp18_;
		GVariant* _tmp19_;
		GVariant* _tmp20_;
		GVariant* _tmp21_;
		RemoteServerField* _tmp22_;
		int _tmp22__length;
		int _tmp22__size;
		int _tmp22__length1;
		GVariantIter _tmp23_;
		GVariant* _tmp24_;
		GVariant* _tmp35_;
		RemoteServerApplication* _tmp36_;
		int _tmp36__length;
		int _tmp36__size;
		int _tmp36__length1;
		GVariantIter _tmp37_;
		GVariant* _tmp38_;
		if (_tmp12__size == _tmp12__length) {
			_tmp12__size = 2 * _tmp12__size;
			_tmp12_ = g_renew (RemoteServer, _tmp12_, _tmp12__size + 1);
		}
		g_variant_iter_init (&_tmp16_, _tmp14_);
		_tmp17_ = g_variant_iter_next_value (&_tmp16_);
		_tmp15_.type = g_variant_dup_string (_tmp17_, NULL);
		g_variant_unref (_tmp17_);
		_tmp18_ = g_variant_iter_next_value (&_tmp16_);
		_tmp15_.name = g_variant_dup_string (_tmp18_, NULL);
		g_variant_unref (_tmp18_);
		_tmp19_ = g_variant_iter_next_value (&_tmp16_);
		_tmp15_.url = g_variant_dup_string (_tmp19_, NULL);
		g_variant_unref (_tmp19_);
		_tmp20_ = g_variant_iter_next_value (&_tmp16_);
		_tmp15_.last_used_server = g_variant_get_boolean (_tmp20_);
		g_variant_unref (_tmp20_);
		_tmp21_ = g_variant_iter_next_value (&_tmp16_);
		_tmp22_ = g_new (RemoteServerField, 5);
		_tmp22__length = 0;
		_tmp22__size = 4;
		_tmp22__length1 = 0;
		g_variant_iter_init (&_tmp23_, _tmp21_);
		for (; (_tmp24_ = g_variant_iter_next_value (&_tmp23_)) != NULL; _tmp22__length1++) {
			RemoteServerField _tmp25_;
			GVariantIter _tmp26_;
			GVariant* _tmp27_;
			GVariant* _tmp28_;
			GVariant* _tmp29_;
			GVariant* _tmp30_;
			GHashTable* _tmp31_;
			GVariantIter _tmp32_;
			GVariant* _tmp33_;
			GVariant* _tmp34_;
			if (_tmp22__size == _tmp22__length) {
				_tmp22__size = 2 * _tmp22__size;
				_tmp22_ = g_renew (RemoteServerField, _tmp22_, _tmp22__size + 1);
			}
			g_variant_iter_init (&_tmp26_, _tmp24_);
			_tmp27_ = g_variant_iter_next_value (&_tmp26_);
			_tmp25_.type = g_variant_dup_string (_tmp27_, NULL);
			g_variant_unref (_tmp27_);
			_tmp28_ = g_variant_iter_next_value (&_tmp26_);
			_tmp25_.required = g_variant_get_boolean (_tmp28_);
			g_variant_unref (_tmp28_);
			_tmp29_ = g_variant_iter_next_value (&_tmp26_);
			_tmp25_.default_value = g_variant_get_variant (_tmp29_);
			g_variant_unref (_tmp29_);
			_tmp30_ = g_variant_iter_next_value (&_tmp26_);
			_tmp31_ = g_hash_table_new_full (g_str_hash, g_str_equal, g_free, (GDestroyNotify) g_variant_unref);
			g_variant_iter_init (&_tmp32_, _tmp30_);
			while (g_variant_iter_loop (&_tmp32_, "{?*}", &_tmp33_, &_tmp34_)) {
				g_hash_table_insert (_tmp31_, g_variant_dup_string (_tmp33_, NULL), g_variant_get_variant (_tmp34_));
			}
			_tmp25_.properties = _tmp31_;
			g_variant_unref (_tmp30_);
			_tmp22_[_tmp22__length++] = _tmp25_;
			g_variant_unref (_tmp24_);
		}
		_tmp15_.fields_length1 = _tmp22__length1;
		_tmp15_.fields = _tmp22_;
		g_variant_unref (_tmp21_);
		_tmp35_ = g_variant_iter_next_value (&_tmp16_);
		_tmp36_ = g_new (RemoteServerApplication, 5);
		_tmp36__length = 0;
		_tmp36__size = 4;
		_tmp36__length1 = 0;
		g_variant_iter_init (&_tmp37_, _tmp35_);
		for (; (_tmp38_ = g_variant_iter_next_value (&_tmp37_)) != NULL; _tmp36__length1++) {
			RemoteServerApplication _tmp39_;
			GVariantIter _tmp40_;
			GVariant* _tmp41_;
			GVariant* _tmp42_;
			if (_tmp36__size == _tmp36__length) {
				_tmp36__size = 2 * _tmp36__size;
				_tmp36_ = g_renew (RemoteServerApplication, _tmp36_, _tmp36__size + 1);
			}
			g_variant_iter_init (&_tmp40_, _tmp38_);
			_tmp41_ = g_variant_iter_next_value (&_tmp40_);
			_tmp39_.application_id = g_variant_dup_string (_tmp41_, NULL);
			g_variant_unref (_tmp41_);
			_tmp42_ = g_variant_iter_next_value (&_tmp40_);
			_tmp39_.pin_position = g_variant_get_int32 (_tmp42_);
			g_variant_unref (_tmp42_);
			_tmp36_[_tmp36__length++] = _tmp39_;
			g_variant_unref (_tmp38_);
		}
		_tmp15_.applications_length1 = _tmp36__length1;
		_tmp15_.applications = _tmp36_;
		g_variant_unref (_tmp35_);
		_tmp12_[_tmp12__length++] = _tmp15_;
		g_variant_unref (_tmp14_);
	}
	serverList_length1 = _tmp12__length1;
	serverList = _tmp12_;
	g_variant_unref (_tmp11_);
	g_signal_emit_by_name (self, "servers-updated", serverList, serverList_length1);
	serverList = (_vala_RemoteServer_array_free (serverList, serverList_length1), NULL);
}


static void _dbus_handle_remote_login_service_login_servers_updated (RemoteLoginService* self, GVariant* parameters) {
	GVariantIter _arguments_iter;
	gchar* url = NULL;
	GVariant* _tmp43_;
	gchar* emailAddress = NULL;
	GVariant* _tmp44_;
	gchar* dataType = NULL;
	GVariant* _tmp45_;
	RemoteServer* serverList = NULL;
	int serverList_length1;
	GVariant* _tmp46_;
	RemoteServer* _tmp47_;
	int _tmp47__length;
	int _tmp47__size;
	int _tmp47__length1;
	GVariantIter _tmp48_;
	GVariant* _tmp49_;
	g_variant_iter_init (&_arguments_iter, parameters);
	_tmp43_ = g_variant_iter_next_value (&_arguments_iter);
	url = g_variant_dup_string (_tmp43_, NULL);
	g_variant_unref (_tmp43_);
	_tmp44_ = g_variant_iter_next_value (&_arguments_iter);
	emailAddress = g_variant_dup_string (_tmp44_, NULL);
	g_variant_unref (_tmp44_);
	_tmp45_ = g_variant_iter_next_value (&_arguments_iter);
	dataType = g_variant_dup_string (_tmp45_, NULL);
	g_variant_unref (_tmp45_);
	serverList_length1 = 0;
	_tmp46_ = g_variant_iter_next_value (&_arguments_iter);
	_tmp47_ = g_new (RemoteServer, 5);
	_tmp47__length = 0;
	_tmp47__size = 4;
	_tmp47__length1 = 0;
	g_variant_iter_init (&_tmp48_, _tmp46_);
	for (; (_tmp49_ = g_variant_iter_next_value (&_tmp48_)) != NULL; _tmp47__length1++) {
		RemoteServer _tmp50_;
		GVariantIter _tmp51_;
		GVariant* _tmp52_;
		GVariant* _tmp53_;
		GVariant* _tmp54_;
		GVariant* _tmp55_;
		GVariant* _tmp56_;
		RemoteServerField* _tmp57_;
		int _tmp57__length;
		int _tmp57__size;
		int _tmp57__length1;
		GVariantIter _tmp58_;
		GVariant* _tmp59_;
		GVariant* _tmp70_;
		RemoteServerApplication* _tmp71_;
		int _tmp71__length;
		int _tmp71__size;
		int _tmp71__length1;
		GVariantIter _tmp72_;
		GVariant* _tmp73_;
		if (_tmp47__size == _tmp47__length) {
			_tmp47__size = 2 * _tmp47__size;
			_tmp47_ = g_renew (RemoteServer, _tmp47_, _tmp47__size + 1);
		}
		g_variant_iter_init (&_tmp51_, _tmp49_);
		_tmp52_ = g_variant_iter_next_value (&_tmp51_);
		_tmp50_.type = g_variant_dup_string (_tmp52_, NULL);
		g_variant_unref (_tmp52_);
		_tmp53_ = g_variant_iter_next_value (&_tmp51_);
		_tmp50_.name = g_variant_dup_string (_tmp53_, NULL);
		g_variant_unref (_tmp53_);
		_tmp54_ = g_variant_iter_next_value (&_tmp51_);
		_tmp50_.url = g_variant_dup_string (_tmp54_, NULL);
		g_variant_unref (_tmp54_);
		_tmp55_ = g_variant_iter_next_value (&_tmp51_);
		_tmp50_.last_used_server = g_variant_get_boolean (_tmp55_);
		g_variant_unref (_tmp55_);
		_tmp56_ = g_variant_iter_next_value (&_tmp51_);
		_tmp57_ = g_new (RemoteServerField, 5);
		_tmp57__length = 0;
		_tmp57__size = 4;
		_tmp57__length1 = 0;
		g_variant_iter_init (&_tmp58_, _tmp56_);
		for (; (_tmp59_ = g_variant_iter_next_value (&_tmp58_)) != NULL; _tmp57__length1++) {
			RemoteServerField _tmp60_;
			GVariantIter _tmp61_;
			GVariant* _tmp62_;
			GVariant* _tmp63_;
			GVariant* _tmp64_;
			GVariant* _tmp65_;
			GHashTable* _tmp66_;
			GVariantIter _tmp67_;
			GVariant* _tmp68_;
			GVariant* _tmp69_;
			if (_tmp57__size == _tmp57__length) {
				_tmp57__size = 2 * _tmp57__size;
				_tmp57_ = g_renew (RemoteServerField, _tmp57_, _tmp57__size + 1);
			}
			g_variant_iter_init (&_tmp61_, _tmp59_);
			_tmp62_ = g_variant_iter_next_value (&_tmp61_);
			_tmp60_.type = g_variant_dup_string (_tmp62_, NULL);
			g_variant_unref (_tmp62_);
			_tmp63_ = g_variant_iter_next_value (&_tmp61_);
			_tmp60_.required = g_variant_get_boolean (_tmp63_);
			g_variant_unref (_tmp63_);
			_tmp64_ = g_variant_iter_next_value (&_tmp61_);
			_tmp60_.default_value = g_variant_get_variant (_tmp64_);
			g_variant_unref (_tmp64_);
			_tmp65_ = g_variant_iter_next_value (&_tmp61_);
			_tmp66_ = g_hash_table_new_full (g_str_hash, g_str_equal, g_free, (GDestroyNotify) g_variant_unref);
			g_variant_iter_init (&_tmp67_, _tmp65_);
			while (g_variant_iter_loop (&_tmp67_, "{?*}", &_tmp68_, &_tmp69_)) {
				g_hash_table_insert (_tmp66_, g_variant_dup_string (_tmp68_, NULL), g_variant_get_variant (_tmp69_));
			}
			_tmp60_.properties = _tmp66_;
			g_variant_unref (_tmp65_);
			_tmp57_[_tmp57__length++] = _tmp60_;
			g_variant_unref (_tmp59_);
		}
		_tmp50_.fields_length1 = _tmp57__length1;
		_tmp50_.fields = _tmp57_;
		g_variant_unref (_tmp56_);
		_tmp70_ = g_variant_iter_next_value (&_tmp51_);
		_tmp71_ = g_new (RemoteServerApplication, 5);
		_tmp71__length = 0;
		_tmp71__size = 4;
		_tmp71__length1 = 0;
		g_variant_iter_init (&_tmp72_, _tmp70_);
		for (; (_tmp73_ = g_variant_iter_next_value (&_tmp72_)) != NULL; _tmp71__length1++) {
			RemoteServerApplication _tmp74_;
			GVariantIter _tmp75_;
			GVariant* _tmp76_;
			GVariant* _tmp77_;
			if (_tmp71__size == _tmp71__length) {
				_tmp71__size = 2 * _tmp71__size;
				_tmp71_ = g_renew (RemoteServerApplication, _tmp71_, _tmp71__size + 1);
			}
			g_variant_iter_init (&_tmp75_, _tmp73_);
			_tmp76_ = g_variant_iter_next_value (&_tmp75_);
			_tmp74_.application_id = g_variant_dup_string (_tmp76_, NULL);
			g_variant_unref (_tmp76_);
			_tmp77_ = g_variant_iter_next_value (&_tmp75_);
			_tmp74_.pin_position = g_variant_get_int32 (_tmp77_);
			g_variant_unref (_tmp77_);
			_tmp71_[_tmp71__length++] = _tmp74_;
			g_variant_unref (_tmp73_);
		}
		_tmp50_.applications_length1 = _tmp71__length1;
		_tmp50_.applications = _tmp71_;
		g_variant_unref (_tmp70_);
		_tmp47_[_tmp47__length++] = _tmp50_;
		g_variant_unref (_tmp49_);
	}
	serverList_length1 = _tmp47__length1;
	serverList = _tmp47_;
	g_variant_unref (_tmp46_);
	g_signal_emit_by_name (self, "login-servers-updated", url, emailAddress, dataType, serverList, serverList_length1);
	_g_free0 (url);
	_g_free0 (emailAddress);
	_g_free0 (dataType);
	serverList = (_vala_RemoteServer_array_free (serverList, serverList_length1), NULL);
}


static void _dbus_handle_remote_login_service_login_changed (RemoteLoginService* self, GVariant* parameters) {
	GVariantIter _arguments_iter;
	gchar* url = NULL;
	GVariant* _tmp78_;
	gchar* emailAddress = NULL;
	GVariant* _tmp79_;
	g_variant_iter_init (&_arguments_iter, parameters);
	_tmp78_ = g_variant_iter_next_value (&_arguments_iter);
	url = g_variant_dup_string (_tmp78_, NULL);
	g_variant_unref (_tmp78_);
	_tmp79_ = g_variant_iter_next_value (&_arguments_iter);
	emailAddress = g_variant_dup_string (_tmp79_, NULL);
	g_variant_unref (_tmp79_);
	g_signal_emit_by_name (self, "login-changed", url, emailAddress);
	_g_free0 (url);
	_g_free0 (emailAddress);
}


static void remote_login_service_proxy_g_signal (GDBusProxy* proxy, const gchar* sender_name, const gchar* signal_name, GVariant* parameters) {
	if (strcmp (signal_name, "ServersUpdated") == 0) {
		_dbus_handle_remote_login_service_servers_updated ((RemoteLoginService*) proxy, parameters);
	} else if (strcmp (signal_name, "LoginServersUpdated") == 0) {
		_dbus_handle_remote_login_service_login_servers_updated ((RemoteLoginService*) proxy, parameters);
	} else if (strcmp (signal_name, "LoginChanged") == 0) {
		_dbus_handle_remote_login_service_login_changed ((RemoteLoginService*) proxy, parameters);
	}
}


static void remote_login_service_proxy_init (RemoteLoginServiceProxy* self) {
}


static void _vala_g_async_ready_callback (GObject *source_object, GAsyncResult *res, void *user_data) {
	g_simple_async_result_set_op_res_gpointer (user_data, g_object_ref (res), g_object_unref);
	g_simple_async_result_complete (user_data);
	g_object_unref (user_data);
}


static void remote_login_service_proxy_get_servers_async (RemoteLoginService* self, GAsyncReadyCallback _callback_, gpointer _user_data_) {
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	G_IO_ERROR;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "com.canonical.RemoteLogin", "GetServers");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	g_dbus_connection_send_message_with_reply (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, _vala_g_async_ready_callback, g_simple_async_result_new ((GObject *) self, _callback_, _user_data_, NULL));
	g_object_unref (_message);
}


static void remote_login_service_proxy_get_servers_finish (RemoteLoginService* self, GAsyncResult* _res_, RemoteServer** serverList, int* serverList_length1, GError** error) {
	GDBusMessage *_reply_message;
	GVariant *_reply;
	GVariantIter _reply_iter;
	RemoteServer* _vala_serverList;
	int _vala_serverList_length1;
	GVariant* _tmp80_;
	RemoteServer* _tmp81_;
	int _tmp81__length;
	int _tmp81__size;
	int _tmp81__length1;
	GVariantIter _tmp82_;
	GVariant* _tmp83_;
	_reply_message = g_dbus_connection_send_message_with_reply_finish (g_dbus_proxy_get_connection ((GDBusProxy *) self), g_simple_async_result_get_op_res_gpointer ((GSimpleAsyncResult *) _res_), error);
	if (!_reply_message) {
		return;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return;
	}
	_reply = g_dbus_message_get_body (_reply_message);
	g_variant_iter_init (&_reply_iter, _reply);
	_vala_serverList_length1 = 0;
	_tmp80_ = g_variant_iter_next_value (&_reply_iter);
	_tmp81_ = g_new (RemoteServer, 5);
	_tmp81__length = 0;
	_tmp81__size = 4;
	_tmp81__length1 = 0;
	g_variant_iter_init (&_tmp82_, _tmp80_);
	for (; (_tmp83_ = g_variant_iter_next_value (&_tmp82_)) != NULL; _tmp81__length1++) {
		RemoteServer _tmp84_;
		GVariantIter _tmp85_;
		GVariant* _tmp86_;
		GVariant* _tmp87_;
		GVariant* _tmp88_;
		GVariant* _tmp89_;
		GVariant* _tmp90_;
		RemoteServerField* _tmp91_;
		int _tmp91__length;
		int _tmp91__size;
		int _tmp91__length1;
		GVariantIter _tmp92_;
		GVariant* _tmp93_;
		GVariant* _tmp104_;
		RemoteServerApplication* _tmp105_;
		int _tmp105__length;
		int _tmp105__size;
		int _tmp105__length1;
		GVariantIter _tmp106_;
		GVariant* _tmp107_;
		if (_tmp81__size == _tmp81__length) {
			_tmp81__size = 2 * _tmp81__size;
			_tmp81_ = g_renew (RemoteServer, _tmp81_, _tmp81__size + 1);
		}
		g_variant_iter_init (&_tmp85_, _tmp83_);
		_tmp86_ = g_variant_iter_next_value (&_tmp85_);
		_tmp84_.type = g_variant_dup_string (_tmp86_, NULL);
		g_variant_unref (_tmp86_);
		_tmp87_ = g_variant_iter_next_value (&_tmp85_);
		_tmp84_.name = g_variant_dup_string (_tmp87_, NULL);
		g_variant_unref (_tmp87_);
		_tmp88_ = g_variant_iter_next_value (&_tmp85_);
		_tmp84_.url = g_variant_dup_string (_tmp88_, NULL);
		g_variant_unref (_tmp88_);
		_tmp89_ = g_variant_iter_next_value (&_tmp85_);
		_tmp84_.last_used_server = g_variant_get_boolean (_tmp89_);
		g_variant_unref (_tmp89_);
		_tmp90_ = g_variant_iter_next_value (&_tmp85_);
		_tmp91_ = g_new (RemoteServerField, 5);
		_tmp91__length = 0;
		_tmp91__size = 4;
		_tmp91__length1 = 0;
		g_variant_iter_init (&_tmp92_, _tmp90_);
		for (; (_tmp93_ = g_variant_iter_next_value (&_tmp92_)) != NULL; _tmp91__length1++) {
			RemoteServerField _tmp94_;
			GVariantIter _tmp95_;
			GVariant* _tmp96_;
			GVariant* _tmp97_;
			GVariant* _tmp98_;
			GVariant* _tmp99_;
			GHashTable* _tmp100_;
			GVariantIter _tmp101_;
			GVariant* _tmp102_;
			GVariant* _tmp103_;
			if (_tmp91__size == _tmp91__length) {
				_tmp91__size = 2 * _tmp91__size;
				_tmp91_ = g_renew (RemoteServerField, _tmp91_, _tmp91__size + 1);
			}
			g_variant_iter_init (&_tmp95_, _tmp93_);
			_tmp96_ = g_variant_iter_next_value (&_tmp95_);
			_tmp94_.type = g_variant_dup_string (_tmp96_, NULL);
			g_variant_unref (_tmp96_);
			_tmp97_ = g_variant_iter_next_value (&_tmp95_);
			_tmp94_.required = g_variant_get_boolean (_tmp97_);
			g_variant_unref (_tmp97_);
			_tmp98_ = g_variant_iter_next_value (&_tmp95_);
			_tmp94_.default_value = g_variant_get_variant (_tmp98_);
			g_variant_unref (_tmp98_);
			_tmp99_ = g_variant_iter_next_value (&_tmp95_);
			_tmp100_ = g_hash_table_new_full (g_str_hash, g_str_equal, g_free, (GDestroyNotify) g_variant_unref);
			g_variant_iter_init (&_tmp101_, _tmp99_);
			while (g_variant_iter_loop (&_tmp101_, "{?*}", &_tmp102_, &_tmp103_)) {
				g_hash_table_insert (_tmp100_, g_variant_dup_string (_tmp102_, NULL), g_variant_get_variant (_tmp103_));
			}
			_tmp94_.properties = _tmp100_;
			g_variant_unref (_tmp99_);
			_tmp91_[_tmp91__length++] = _tmp94_;
			g_variant_unref (_tmp93_);
		}
		_tmp84_.fields_length1 = _tmp91__length1;
		_tmp84_.fields = _tmp91_;
		g_variant_unref (_tmp90_);
		_tmp104_ = g_variant_iter_next_value (&_tmp85_);
		_tmp105_ = g_new (RemoteServerApplication, 5);
		_tmp105__length = 0;
		_tmp105__size = 4;
		_tmp105__length1 = 0;
		g_variant_iter_init (&_tmp106_, _tmp104_);
		for (; (_tmp107_ = g_variant_iter_next_value (&_tmp106_)) != NULL; _tmp105__length1++) {
			RemoteServerApplication _tmp108_;
			GVariantIter _tmp109_;
			GVariant* _tmp110_;
			GVariant* _tmp111_;
			if (_tmp105__size == _tmp105__length) {
				_tmp105__size = 2 * _tmp105__size;
				_tmp105_ = g_renew (RemoteServerApplication, _tmp105_, _tmp105__size + 1);
			}
			g_variant_iter_init (&_tmp109_, _tmp107_);
			_tmp110_ = g_variant_iter_next_value (&_tmp109_);
			_tmp108_.application_id = g_variant_dup_string (_tmp110_, NULL);
			g_variant_unref (_tmp110_);
			_tmp111_ = g_variant_iter_next_value (&_tmp109_);
			_tmp108_.pin_position = g_variant_get_int32 (_tmp111_);
			g_variant_unref (_tmp111_);
			_tmp105_[_tmp105__length++] = _tmp108_;
			g_variant_unref (_tmp107_);
		}
		_tmp84_.applications_length1 = _tmp105__length1;
		_tmp84_.applications = _tmp105_;
		g_variant_unref (_tmp104_);
		_tmp81_[_tmp81__length++] = _tmp84_;
		g_variant_unref (_tmp83_);
	}
	_vala_serverList_length1 = _tmp81__length1;
	_vala_serverList = _tmp81_;
	g_variant_unref (_tmp80_);
	*serverList = _vala_serverList;
	*serverList_length1 = _vala_serverList_length1;
	g_object_unref (_reply_message);
}


static void remote_login_service_proxy_get_servers_for_login_async (RemoteLoginService* self, const gchar* url, const gchar* emailAddress, const gchar* password, gboolean allowCache, GAsyncReadyCallback _callback_, gpointer _user_data_) {
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	G_IO_ERROR;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "com.canonical.RemoteLogin", "GetServersForLogin");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (url));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (emailAddress));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (password));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_boolean (allowCache));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	g_dbus_connection_send_message_with_reply (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, _vala_g_async_ready_callback, g_simple_async_result_new ((GObject *) self, _callback_, _user_data_, NULL));
	g_object_unref (_message);
}


static void remote_login_service_proxy_get_servers_for_login_finish (RemoteLoginService* self, GAsyncResult* _res_, gboolean* loginSuccess, gchar** dataType, RemoteServer** serverList, int* serverList_length1, GError** error) {
	GDBusMessage *_reply_message;
	GVariant *_reply;
	GVariantIter _reply_iter;
	gboolean _vala_loginSuccess;
	GVariant* _tmp112_;
	gchar* _vala_dataType;
	GVariant* _tmp113_;
	RemoteServer* _vala_serverList;
	int _vala_serverList_length1;
	GVariant* _tmp114_;
	RemoteServer* _tmp115_;
	int _tmp115__length;
	int _tmp115__size;
	int _tmp115__length1;
	GVariantIter _tmp116_;
	GVariant* _tmp117_;
	_reply_message = g_dbus_connection_send_message_with_reply_finish (g_dbus_proxy_get_connection ((GDBusProxy *) self), g_simple_async_result_get_op_res_gpointer ((GSimpleAsyncResult *) _res_), error);
	if (!_reply_message) {
		return;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return;
	}
	_reply = g_dbus_message_get_body (_reply_message);
	g_variant_iter_init (&_reply_iter, _reply);
	_tmp112_ = g_variant_iter_next_value (&_reply_iter);
	_vala_loginSuccess = g_variant_get_boolean (_tmp112_);
	g_variant_unref (_tmp112_);
	*loginSuccess = _vala_loginSuccess;
	_tmp113_ = g_variant_iter_next_value (&_reply_iter);
	_vala_dataType = g_variant_dup_string (_tmp113_, NULL);
	g_variant_unref (_tmp113_);
	*dataType = _vala_dataType;
	_vala_serverList_length1 = 0;
	_tmp114_ = g_variant_iter_next_value (&_reply_iter);
	_tmp115_ = g_new (RemoteServer, 5);
	_tmp115__length = 0;
	_tmp115__size = 4;
	_tmp115__length1 = 0;
	g_variant_iter_init (&_tmp116_, _tmp114_);
	for (; (_tmp117_ = g_variant_iter_next_value (&_tmp116_)) != NULL; _tmp115__length1++) {
		RemoteServer _tmp118_;
		GVariantIter _tmp119_;
		GVariant* _tmp120_;
		GVariant* _tmp121_;
		GVariant* _tmp122_;
		GVariant* _tmp123_;
		GVariant* _tmp124_;
		RemoteServerField* _tmp125_;
		int _tmp125__length;
		int _tmp125__size;
		int _tmp125__length1;
		GVariantIter _tmp126_;
		GVariant* _tmp127_;
		GVariant* _tmp138_;
		RemoteServerApplication* _tmp139_;
		int _tmp139__length;
		int _tmp139__size;
		int _tmp139__length1;
		GVariantIter _tmp140_;
		GVariant* _tmp141_;
		if (_tmp115__size == _tmp115__length) {
			_tmp115__size = 2 * _tmp115__size;
			_tmp115_ = g_renew (RemoteServer, _tmp115_, _tmp115__size + 1);
		}
		g_variant_iter_init (&_tmp119_, _tmp117_);
		_tmp120_ = g_variant_iter_next_value (&_tmp119_);
		_tmp118_.type = g_variant_dup_string (_tmp120_, NULL);
		g_variant_unref (_tmp120_);
		_tmp121_ = g_variant_iter_next_value (&_tmp119_);
		_tmp118_.name = g_variant_dup_string (_tmp121_, NULL);
		g_variant_unref (_tmp121_);
		_tmp122_ = g_variant_iter_next_value (&_tmp119_);
		_tmp118_.url = g_variant_dup_string (_tmp122_, NULL);
		g_variant_unref (_tmp122_);
		_tmp123_ = g_variant_iter_next_value (&_tmp119_);
		_tmp118_.last_used_server = g_variant_get_boolean (_tmp123_);
		g_variant_unref (_tmp123_);
		_tmp124_ = g_variant_iter_next_value (&_tmp119_);
		_tmp125_ = g_new (RemoteServerField, 5);
		_tmp125__length = 0;
		_tmp125__size = 4;
		_tmp125__length1 = 0;
		g_variant_iter_init (&_tmp126_, _tmp124_);
		for (; (_tmp127_ = g_variant_iter_next_value (&_tmp126_)) != NULL; _tmp125__length1++) {
			RemoteServerField _tmp128_;
			GVariantIter _tmp129_;
			GVariant* _tmp130_;
			GVariant* _tmp131_;
			GVariant* _tmp132_;
			GVariant* _tmp133_;
			GHashTable* _tmp134_;
			GVariantIter _tmp135_;
			GVariant* _tmp136_;
			GVariant* _tmp137_;
			if (_tmp125__size == _tmp125__length) {
				_tmp125__size = 2 * _tmp125__size;
				_tmp125_ = g_renew (RemoteServerField, _tmp125_, _tmp125__size + 1);
			}
			g_variant_iter_init (&_tmp129_, _tmp127_);
			_tmp130_ = g_variant_iter_next_value (&_tmp129_);
			_tmp128_.type = g_variant_dup_string (_tmp130_, NULL);
			g_variant_unref (_tmp130_);
			_tmp131_ = g_variant_iter_next_value (&_tmp129_);
			_tmp128_.required = g_variant_get_boolean (_tmp131_);
			g_variant_unref (_tmp131_);
			_tmp132_ = g_variant_iter_next_value (&_tmp129_);
			_tmp128_.default_value = g_variant_get_variant (_tmp132_);
			g_variant_unref (_tmp132_);
			_tmp133_ = g_variant_iter_next_value (&_tmp129_);
			_tmp134_ = g_hash_table_new_full (g_str_hash, g_str_equal, g_free, (GDestroyNotify) g_variant_unref);
			g_variant_iter_init (&_tmp135_, _tmp133_);
			while (g_variant_iter_loop (&_tmp135_, "{?*}", &_tmp136_, &_tmp137_)) {
				g_hash_table_insert (_tmp134_, g_variant_dup_string (_tmp136_, NULL), g_variant_get_variant (_tmp137_));
			}
			_tmp128_.properties = _tmp134_;
			g_variant_unref (_tmp133_);
			_tmp125_[_tmp125__length++] = _tmp128_;
			g_variant_unref (_tmp127_);
		}
		_tmp118_.fields_length1 = _tmp125__length1;
		_tmp118_.fields = _tmp125_;
		g_variant_unref (_tmp124_);
		_tmp138_ = g_variant_iter_next_value (&_tmp119_);
		_tmp139_ = g_new (RemoteServerApplication, 5);
		_tmp139__length = 0;
		_tmp139__size = 4;
		_tmp139__length1 = 0;
		g_variant_iter_init (&_tmp140_, _tmp138_);
		for (; (_tmp141_ = g_variant_iter_next_value (&_tmp140_)) != NULL; _tmp139__length1++) {
			RemoteServerApplication _tmp142_;
			GVariantIter _tmp143_;
			GVariant* _tmp144_;
			GVariant* _tmp145_;
			if (_tmp139__size == _tmp139__length) {
				_tmp139__size = 2 * _tmp139__size;
				_tmp139_ = g_renew (RemoteServerApplication, _tmp139_, _tmp139__size + 1);
			}
			g_variant_iter_init (&_tmp143_, _tmp141_);
			_tmp144_ = g_variant_iter_next_value (&_tmp143_);
			_tmp142_.application_id = g_variant_dup_string (_tmp144_, NULL);
			g_variant_unref (_tmp144_);
			_tmp145_ = g_variant_iter_next_value (&_tmp143_);
			_tmp142_.pin_position = g_variant_get_int32 (_tmp145_);
			g_variant_unref (_tmp145_);
			_tmp139_[_tmp139__length++] = _tmp142_;
			g_variant_unref (_tmp141_);
		}
		_tmp118_.applications_length1 = _tmp139__length1;
		_tmp118_.applications = _tmp139_;
		g_variant_unref (_tmp138_);
		_tmp115_[_tmp115__length++] = _tmp118_;
		g_variant_unref (_tmp117_);
	}
	_vala_serverList_length1 = _tmp115__length1;
	_vala_serverList = _tmp115_;
	g_variant_unref (_tmp114_);
	*serverList = _vala_serverList;
	*serverList_length1 = _vala_serverList_length1;
	g_object_unref (_reply_message);
}


static void remote_login_service_proxy_get_cached_domains_for_server_async (RemoteLoginService* self, const gchar* url, GAsyncReadyCallback _callback_, gpointer _user_data_) {
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	G_IO_ERROR;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "com.canonical.RemoteLogin", "GetCachedDomainsForServer");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (url));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	g_dbus_connection_send_message_with_reply (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, _vala_g_async_ready_callback, g_simple_async_result_new ((GObject *) self, _callback_, _user_data_, NULL));
	g_object_unref (_message);
}


static void remote_login_service_proxy_get_cached_domains_for_server_finish (RemoteLoginService* self, GAsyncResult* _res_, gchar*** domains, int* domains_length1, GError** error) {
	GDBusMessage *_reply_message;
	GVariant *_reply;
	GVariantIter _reply_iter;
	gchar** _vala_domains;
	int _vala_domains_length1;
	GVariant* _tmp146_;
	gchar** _tmp147_;
	int _tmp147__length;
	int _tmp147__size;
	int _tmp147__length1;
	GVariantIter _tmp148_;
	GVariant* _tmp149_;
	_reply_message = g_dbus_connection_send_message_with_reply_finish (g_dbus_proxy_get_connection ((GDBusProxy *) self), g_simple_async_result_get_op_res_gpointer ((GSimpleAsyncResult *) _res_), error);
	if (!_reply_message) {
		return;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return;
	}
	_reply = g_dbus_message_get_body (_reply_message);
	g_variant_iter_init (&_reply_iter, _reply);
	_vala_domains_length1 = 0;
	_tmp146_ = g_variant_iter_next_value (&_reply_iter);
	_tmp147_ = g_new (gchar*, 5);
	_tmp147__length = 0;
	_tmp147__size = 4;
	_tmp147__length1 = 0;
	g_variant_iter_init (&_tmp148_, _tmp146_);
	for (; (_tmp149_ = g_variant_iter_next_value (&_tmp148_)) != NULL; _tmp147__length1++) {
		if (_tmp147__size == _tmp147__length) {
			_tmp147__size = 2 * _tmp147__size;
			_tmp147_ = g_renew (gchar*, _tmp147_, _tmp147__size + 1);
		}
		_tmp147_[_tmp147__length++] = g_variant_dup_string (_tmp149_, NULL);
		g_variant_unref (_tmp149_);
	}
	_vala_domains_length1 = _tmp147__length1;
	_tmp147_[_tmp147__length] = NULL;
	_vala_domains = _tmp147_;
	g_variant_unref (_tmp146_);
	*domains = _vala_domains;
	*domains_length1 = _vala_domains_length1;
	g_object_unref (_reply_message);
}


static void remote_login_service_proxy_set_last_used_server_async (RemoteLoginService* self, const gchar* uccsUrl, const gchar* serverUrl, GAsyncReadyCallback _callback_, gpointer _user_data_) {
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	G_IO_ERROR;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "com.canonical.RemoteLogin", "SetLastUsedServer");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (uccsUrl));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (serverUrl));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	g_dbus_connection_send_message_with_reply (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, _vala_g_async_ready_callback, g_simple_async_result_new ((GObject *) self, _callback_, _user_data_, NULL));
	g_object_unref (_message);
}


static void remote_login_service_proxy_set_last_used_server_finish (RemoteLoginService* self, GAsyncResult* _res_, GError** error) {
	GDBusMessage *_reply_message;
	_reply_message = g_dbus_connection_send_message_with_reply_finish (g_dbus_proxy_get_connection ((GDBusProxy *) self), g_simple_async_result_get_op_res_gpointer ((GSimpleAsyncResult *) _res_), error);
	if (!_reply_message) {
		return;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return;
	}
	g_object_unref (_reply_message);
}


static void remote_login_service_proxy_remote_login_service_interface_init (RemoteLoginServiceIface* iface) {
	iface->get_servers = remote_login_service_proxy_get_servers_async;
	iface->get_servers_finish = remote_login_service_proxy_get_servers_finish;
	iface->get_servers_for_login = remote_login_service_proxy_get_servers_for_login_async;
	iface->get_servers_for_login_finish = remote_login_service_proxy_get_servers_for_login_finish;
	iface->get_cached_domains_for_server = remote_login_service_proxy_get_cached_domains_for_server_async;
	iface->get_cached_domains_for_server_finish = remote_login_service_proxy_get_cached_domains_for_server_finish;
	iface->set_last_used_server = remote_login_service_proxy_set_last_used_server_async;
	iface->set_last_used_server_finish = remote_login_service_proxy_set_last_used_server_finish;
}


static void _dbus_remote_login_service_get_servers (RemoteLoginService* self, GVariant* _parameters_, GDBusMethodInvocation* invocation) {
	GVariantIter _arguments_iter;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	remote_login_service_get_servers (self, (GAsyncReadyCallback) _dbus_remote_login_service_get_servers_ready, invocation);
}


static void _dbus_remote_login_service_get_servers_ready (GObject * source_object, GAsyncResult * _res_, gpointer _user_data_) {
	GDBusMethodInvocation * invocation;
	GError* error = NULL;
	GDBusMessage* _reply_message;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	RemoteServer* serverList = NULL;
	int serverList_length1 = 0;
	RemoteServer* _tmp150_;
	GVariantBuilder _tmp151_;
	int _tmp152_;
	invocation = _user_data_;
	remote_login_service_get_servers_finish ((RemoteLoginService*) source_object, _res_, &serverList, &serverList_length1, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_tmp150_ = serverList;
	g_variant_builder_init (&_tmp151_, G_VARIANT_TYPE ("a(sssba(sbva{sv})a(si))"));
	for (_tmp152_ = 0; _tmp152_ < serverList_length1; _tmp152_++) {
		GVariantBuilder _tmp153_;
		RemoteServerField* _tmp154_;
		GVariantBuilder _tmp155_;
		int _tmp156_;
		RemoteServerApplication* _tmp162_;
		GVariantBuilder _tmp163_;
		int _tmp164_;
		g_variant_builder_init (&_tmp153_, G_VARIANT_TYPE_TUPLE);
		g_variant_builder_add_value (&_tmp153_, g_variant_new_string ((*_tmp150_).type));
		g_variant_builder_add_value (&_tmp153_, g_variant_new_string ((*_tmp150_).name));
		g_variant_builder_add_value (&_tmp153_, g_variant_new_string ((*_tmp150_).url));
		g_variant_builder_add_value (&_tmp153_, g_variant_new_boolean ((*_tmp150_).last_used_server));
		_tmp154_ = (*_tmp150_).fields;
		g_variant_builder_init (&_tmp155_, G_VARIANT_TYPE ("a(sbva{sv})"));
		for (_tmp156_ = 0; _tmp156_ < (*_tmp150_).fields_length1; _tmp156_++) {
			GVariantBuilder _tmp157_;
			GVariantBuilder _tmp158_;
			GHashTableIter _tmp159_;
			gpointer _tmp160_;
			gpointer _tmp161_;
			g_variant_builder_init (&_tmp157_, G_VARIANT_TYPE_TUPLE);
			g_variant_builder_add_value (&_tmp157_, g_variant_new_string ((*_tmp154_).type));
			g_variant_builder_add_value (&_tmp157_, g_variant_new_boolean ((*_tmp154_).required));
			g_variant_builder_add_value (&_tmp157_, g_variant_new_variant ((*_tmp154_).default_value));
			g_hash_table_iter_init (&_tmp159_, (*_tmp154_).properties);
			g_variant_builder_init (&_tmp158_, G_VARIANT_TYPE ("a{sv}"));
			while (g_hash_table_iter_next (&_tmp159_, &_tmp160_, &_tmp161_)) {
				gchar* _key;
				GVariant* _value;
				_key = (gchar*) _tmp160_;
				_value = (GVariant*) _tmp161_;
				g_variant_builder_add (&_tmp158_, "{?*}", g_variant_new_string (_key), g_variant_new_variant (_value));
			}
			g_variant_builder_add_value (&_tmp157_, g_variant_builder_end (&_tmp158_));
			g_variant_builder_add_value (&_tmp155_, g_variant_builder_end (&_tmp157_));
			_tmp154_++;
		}
		g_variant_builder_add_value (&_tmp153_, g_variant_builder_end (&_tmp155_));
		_tmp162_ = (*_tmp150_).applications;
		g_variant_builder_init (&_tmp163_, G_VARIANT_TYPE ("a(si)"));
		for (_tmp164_ = 0; _tmp164_ < (*_tmp150_).applications_length1; _tmp164_++) {
			GVariantBuilder _tmp165_;
			g_variant_builder_init (&_tmp165_, G_VARIANT_TYPE_TUPLE);
			g_variant_builder_add_value (&_tmp165_, g_variant_new_string ((*_tmp162_).application_id));
			g_variant_builder_add_value (&_tmp165_, g_variant_new_int32 ((*_tmp162_).pin_position));
			g_variant_builder_add_value (&_tmp163_, g_variant_builder_end (&_tmp165_));
			_tmp162_++;
		}
		g_variant_builder_add_value (&_tmp153_, g_variant_builder_end (&_tmp163_));
		g_variant_builder_add_value (&_tmp151_, g_variant_builder_end (&_tmp153_));
		_tmp150_++;
	}
	g_variant_builder_add_value (&_reply_builder, g_variant_builder_end (&_tmp151_));
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	serverList = (_vala_RemoteServer_array_free (serverList, serverList_length1), NULL);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}


static void _dbus_remote_login_service_get_servers_for_login (RemoteLoginService* self, GVariant* _parameters_, GDBusMethodInvocation* invocation) {
	GVariantIter _arguments_iter;
	gchar* url = NULL;
	GVariant* _tmp166_;
	gchar* emailAddress = NULL;
	GVariant* _tmp167_;
	gchar* password = NULL;
	GVariant* _tmp168_;
	gboolean allowCache = FALSE;
	GVariant* _tmp169_;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp166_ = g_variant_iter_next_value (&_arguments_iter);
	url = g_variant_dup_string (_tmp166_, NULL);
	g_variant_unref (_tmp166_);
	_tmp167_ = g_variant_iter_next_value (&_arguments_iter);
	emailAddress = g_variant_dup_string (_tmp167_, NULL);
	g_variant_unref (_tmp167_);
	_tmp168_ = g_variant_iter_next_value (&_arguments_iter);
	password = g_variant_dup_string (_tmp168_, NULL);
	g_variant_unref (_tmp168_);
	_tmp169_ = g_variant_iter_next_value (&_arguments_iter);
	allowCache = g_variant_get_boolean (_tmp169_);
	g_variant_unref (_tmp169_);
	remote_login_service_get_servers_for_login (self, url, emailAddress, password, allowCache, (GAsyncReadyCallback) _dbus_remote_login_service_get_servers_for_login_ready, invocation);
	_g_free0 (url);
	_g_free0 (emailAddress);
	_g_free0 (password);
}


static void _dbus_remote_login_service_get_servers_for_login_ready (GObject * source_object, GAsyncResult * _res_, gpointer _user_data_) {
	GDBusMethodInvocation * invocation;
	GError* error = NULL;
	GDBusMessage* _reply_message;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	gboolean loginSuccess = FALSE;
	gchar* dataType = NULL;
	RemoteServer* serverList = NULL;
	int serverList_length1 = 0;
	RemoteServer* _tmp170_;
	GVariantBuilder _tmp171_;
	int _tmp172_;
	invocation = _user_data_;
	remote_login_service_get_servers_for_login_finish ((RemoteLoginService*) source_object, _res_, &loginSuccess, &dataType, &serverList, &serverList_length1, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_reply_builder, g_variant_new_boolean (loginSuccess));
	g_variant_builder_add_value (&_reply_builder, g_variant_new_string (dataType));
	_tmp170_ = serverList;
	g_variant_builder_init (&_tmp171_, G_VARIANT_TYPE ("a(sssba(sbva{sv})a(si))"));
	for (_tmp172_ = 0; _tmp172_ < serverList_length1; _tmp172_++) {
		GVariantBuilder _tmp173_;
		RemoteServerField* _tmp174_;
		GVariantBuilder _tmp175_;
		int _tmp176_;
		RemoteServerApplication* _tmp182_;
		GVariantBuilder _tmp183_;
		int _tmp184_;
		g_variant_builder_init (&_tmp173_, G_VARIANT_TYPE_TUPLE);
		g_variant_builder_add_value (&_tmp173_, g_variant_new_string ((*_tmp170_).type));
		g_variant_builder_add_value (&_tmp173_, g_variant_new_string ((*_tmp170_).name));
		g_variant_builder_add_value (&_tmp173_, g_variant_new_string ((*_tmp170_).url));
		g_variant_builder_add_value (&_tmp173_, g_variant_new_boolean ((*_tmp170_).last_used_server));
		_tmp174_ = (*_tmp170_).fields;
		g_variant_builder_init (&_tmp175_, G_VARIANT_TYPE ("a(sbva{sv})"));
		for (_tmp176_ = 0; _tmp176_ < (*_tmp170_).fields_length1; _tmp176_++) {
			GVariantBuilder _tmp177_;
			GVariantBuilder _tmp178_;
			GHashTableIter _tmp179_;
			gpointer _tmp180_;
			gpointer _tmp181_;
			g_variant_builder_init (&_tmp177_, G_VARIANT_TYPE_TUPLE);
			g_variant_builder_add_value (&_tmp177_, g_variant_new_string ((*_tmp174_).type));
			g_variant_builder_add_value (&_tmp177_, g_variant_new_boolean ((*_tmp174_).required));
			g_variant_builder_add_value (&_tmp177_, g_variant_new_variant ((*_tmp174_).default_value));
			g_hash_table_iter_init (&_tmp179_, (*_tmp174_).properties);
			g_variant_builder_init (&_tmp178_, G_VARIANT_TYPE ("a{sv}"));
			while (g_hash_table_iter_next (&_tmp179_, &_tmp180_, &_tmp181_)) {
				gchar* _key;
				GVariant* _value;
				_key = (gchar*) _tmp180_;
				_value = (GVariant*) _tmp181_;
				g_variant_builder_add (&_tmp178_, "{?*}", g_variant_new_string (_key), g_variant_new_variant (_value));
			}
			g_variant_builder_add_value (&_tmp177_, g_variant_builder_end (&_tmp178_));
			g_variant_builder_add_value (&_tmp175_, g_variant_builder_end (&_tmp177_));
			_tmp174_++;
		}
		g_variant_builder_add_value (&_tmp173_, g_variant_builder_end (&_tmp175_));
		_tmp182_ = (*_tmp170_).applications;
		g_variant_builder_init (&_tmp183_, G_VARIANT_TYPE ("a(si)"));
		for (_tmp184_ = 0; _tmp184_ < (*_tmp170_).applications_length1; _tmp184_++) {
			GVariantBuilder _tmp185_;
			g_variant_builder_init (&_tmp185_, G_VARIANT_TYPE_TUPLE);
			g_variant_builder_add_value (&_tmp185_, g_variant_new_string ((*_tmp182_).application_id));
			g_variant_builder_add_value (&_tmp185_, g_variant_new_int32 ((*_tmp182_).pin_position));
			g_variant_builder_add_value (&_tmp183_, g_variant_builder_end (&_tmp185_));
			_tmp182_++;
		}
		g_variant_builder_add_value (&_tmp173_, g_variant_builder_end (&_tmp183_));
		g_variant_builder_add_value (&_tmp171_, g_variant_builder_end (&_tmp173_));
		_tmp170_++;
	}
	g_variant_builder_add_value (&_reply_builder, g_variant_builder_end (&_tmp171_));
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	_g_free0 (dataType);
	serverList = (_vala_RemoteServer_array_free (serverList, serverList_length1), NULL);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}


static void _dbus_remote_login_service_get_cached_domains_for_server (RemoteLoginService* self, GVariant* _parameters_, GDBusMethodInvocation* invocation) {
	GVariantIter _arguments_iter;
	gchar* url = NULL;
	GVariant* _tmp186_;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp186_ = g_variant_iter_next_value (&_arguments_iter);
	url = g_variant_dup_string (_tmp186_, NULL);
	g_variant_unref (_tmp186_);
	remote_login_service_get_cached_domains_for_server (self, url, (GAsyncReadyCallback) _dbus_remote_login_service_get_cached_domains_for_server_ready, invocation);
	_g_free0 (url);
}


static void _dbus_remote_login_service_get_cached_domains_for_server_ready (GObject * source_object, GAsyncResult * _res_, gpointer _user_data_) {
	GDBusMethodInvocation * invocation;
	GError* error = NULL;
	GDBusMessage* _reply_message;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	gchar** domains = NULL;
	int domains_length1 = 0;
	gchar** _tmp187_;
	GVariantBuilder _tmp188_;
	int _tmp189_;
	invocation = _user_data_;
	remote_login_service_get_cached_domains_for_server_finish ((RemoteLoginService*) source_object, _res_, &domains, &domains_length1, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_tmp187_ = domains;
	g_variant_builder_init (&_tmp188_, G_VARIANT_TYPE ("as"));
	for (_tmp189_ = 0; _tmp189_ < domains_length1; _tmp189_++) {
		g_variant_builder_add_value (&_tmp188_, g_variant_new_string (*_tmp187_));
		_tmp187_++;
	}
	g_variant_builder_add_value (&_reply_builder, g_variant_builder_end (&_tmp188_));
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	domains = (_vala_array_free (domains, domains_length1, (GDestroyNotify) g_free), NULL);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}


static void _dbus_remote_login_service_set_last_used_server (RemoteLoginService* self, GVariant* _parameters_, GDBusMethodInvocation* invocation) {
	GVariantIter _arguments_iter;
	gchar* uccsUrl = NULL;
	GVariant* _tmp190_;
	gchar* serverUrl = NULL;
	GVariant* _tmp191_;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp190_ = g_variant_iter_next_value (&_arguments_iter);
	uccsUrl = g_variant_dup_string (_tmp190_, NULL);
	g_variant_unref (_tmp190_);
	_tmp191_ = g_variant_iter_next_value (&_arguments_iter);
	serverUrl = g_variant_dup_string (_tmp191_, NULL);
	g_variant_unref (_tmp191_);
	remote_login_service_set_last_used_server (self, uccsUrl, serverUrl, (GAsyncReadyCallback) _dbus_remote_login_service_set_last_used_server_ready, invocation);
	_g_free0 (uccsUrl);
	_g_free0 (serverUrl);
}


static void _dbus_remote_login_service_set_last_used_server_ready (GObject * source_object, GAsyncResult * _res_, gpointer _user_data_) {
	GDBusMethodInvocation * invocation;
	GError* error = NULL;
	GDBusMessage* _reply_message;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	invocation = _user_data_;
	remote_login_service_set_last_used_server_finish ((RemoteLoginService*) source_object, _res_, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}


static void remote_login_service_dbus_interface_method_call (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* method_name, GVariant* parameters, GDBusMethodInvocation* invocation, gpointer user_data) {
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	if (strcmp (method_name, "GetServers") == 0) {
		_dbus_remote_login_service_get_servers (object, parameters, invocation);
	} else if (strcmp (method_name, "GetServersForLogin") == 0) {
		_dbus_remote_login_service_get_servers_for_login (object, parameters, invocation);
	} else if (strcmp (method_name, "GetCachedDomainsForServer") == 0) {
		_dbus_remote_login_service_get_cached_domains_for_server (object, parameters, invocation);
	} else if (strcmp (method_name, "SetLastUsedServer") == 0) {
		_dbus_remote_login_service_set_last_used_server (object, parameters, invocation);
	} else {
		g_object_unref (invocation);
	}
}


static GVariant* remote_login_service_dbus_interface_get_property (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* property_name, GError** error, gpointer user_data) {
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	return NULL;
}


static gboolean remote_login_service_dbus_interface_set_property (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* property_name, GVariant* value, GError** error, gpointer user_data) {
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	return FALSE;
}


static void _dbus_remote_login_service_servers_updated (GObject* _sender, RemoteServer* serverList, int serverList_length1, gpointer* _data) {
	GDBusConnection * _connection;
	const gchar * _path;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	RemoteServer* _tmp192_;
	GVariantBuilder _tmp193_;
	int _tmp194_;
	_connection = _data[1];
	_path = _data[2];
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	_tmp192_ = serverList;
	g_variant_builder_init (&_tmp193_, G_VARIANT_TYPE ("a(sssba(sbva{sv})a(si))"));
	for (_tmp194_ = 0; _tmp194_ < serverList_length1; _tmp194_++) {
		GVariantBuilder _tmp195_;
		RemoteServerField* _tmp196_;
		GVariantBuilder _tmp197_;
		int _tmp198_;
		RemoteServerApplication* _tmp204_;
		GVariantBuilder _tmp205_;
		int _tmp206_;
		g_variant_builder_init (&_tmp195_, G_VARIANT_TYPE_TUPLE);
		g_variant_builder_add_value (&_tmp195_, g_variant_new_string ((*_tmp192_).type));
		g_variant_builder_add_value (&_tmp195_, g_variant_new_string ((*_tmp192_).name));
		g_variant_builder_add_value (&_tmp195_, g_variant_new_string ((*_tmp192_).url));
		g_variant_builder_add_value (&_tmp195_, g_variant_new_boolean ((*_tmp192_).last_used_server));
		_tmp196_ = (*_tmp192_).fields;
		g_variant_builder_init (&_tmp197_, G_VARIANT_TYPE ("a(sbva{sv})"));
		for (_tmp198_ = 0; _tmp198_ < (*_tmp192_).fields_length1; _tmp198_++) {
			GVariantBuilder _tmp199_;
			GVariantBuilder _tmp200_;
			GHashTableIter _tmp201_;
			gpointer _tmp202_;
			gpointer _tmp203_;
			g_variant_builder_init (&_tmp199_, G_VARIANT_TYPE_TUPLE);
			g_variant_builder_add_value (&_tmp199_, g_variant_new_string ((*_tmp196_).type));
			g_variant_builder_add_value (&_tmp199_, g_variant_new_boolean ((*_tmp196_).required));
			g_variant_builder_add_value (&_tmp199_, g_variant_new_variant ((*_tmp196_).default_value));
			g_hash_table_iter_init (&_tmp201_, (*_tmp196_).properties);
			g_variant_builder_init (&_tmp200_, G_VARIANT_TYPE ("a{sv}"));
			while (g_hash_table_iter_next (&_tmp201_, &_tmp202_, &_tmp203_)) {
				gchar* _key;
				GVariant* _value;
				_key = (gchar*) _tmp202_;
				_value = (GVariant*) _tmp203_;
				g_variant_builder_add (&_tmp200_, "{?*}", g_variant_new_string (_key), g_variant_new_variant (_value));
			}
			g_variant_builder_add_value (&_tmp199_, g_variant_builder_end (&_tmp200_));
			g_variant_builder_add_value (&_tmp197_, g_variant_builder_end (&_tmp199_));
			_tmp196_++;
		}
		g_variant_builder_add_value (&_tmp195_, g_variant_builder_end (&_tmp197_));
		_tmp204_ = (*_tmp192_).applications;
		g_variant_builder_init (&_tmp205_, G_VARIANT_TYPE ("a(si)"));
		for (_tmp206_ = 0; _tmp206_ < (*_tmp192_).applications_length1; _tmp206_++) {
			GVariantBuilder _tmp207_;
			g_variant_builder_init (&_tmp207_, G_VARIANT_TYPE_TUPLE);
			g_variant_builder_add_value (&_tmp207_, g_variant_new_string ((*_tmp204_).application_id));
			g_variant_builder_add_value (&_tmp207_, g_variant_new_int32 ((*_tmp204_).pin_position));
			g_variant_builder_add_value (&_tmp205_, g_variant_builder_end (&_tmp207_));
			_tmp204_++;
		}
		g_variant_builder_add_value (&_tmp195_, g_variant_builder_end (&_tmp205_));
		g_variant_builder_add_value (&_tmp193_, g_variant_builder_end (&_tmp195_));
		_tmp192_++;
	}
	g_variant_builder_add_value (&_arguments_builder, g_variant_builder_end (&_tmp193_));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_connection_emit_signal (_connection, NULL, _path, "com.canonical.RemoteLogin", "ServersUpdated", _arguments, NULL);
}


static void _dbus_remote_login_service_login_servers_updated (GObject* _sender, const gchar* url, const gchar* emailAddress, const gchar* dataType, RemoteServer* serverList, int serverList_length1, gpointer* _data) {
	GDBusConnection * _connection;
	const gchar * _path;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	RemoteServer* _tmp208_;
	GVariantBuilder _tmp209_;
	int _tmp210_;
	_connection = _data[1];
	_path = _data[2];
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (url));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (emailAddress));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (dataType));
	_tmp208_ = serverList;
	g_variant_builder_init (&_tmp209_, G_VARIANT_TYPE ("a(sssba(sbva{sv})a(si))"));
	for (_tmp210_ = 0; _tmp210_ < serverList_length1; _tmp210_++) {
		GVariantBuilder _tmp211_;
		RemoteServerField* _tmp212_;
		GVariantBuilder _tmp213_;
		int _tmp214_;
		RemoteServerApplication* _tmp220_;
		GVariantBuilder _tmp221_;
		int _tmp222_;
		g_variant_builder_init (&_tmp211_, G_VARIANT_TYPE_TUPLE);
		g_variant_builder_add_value (&_tmp211_, g_variant_new_string ((*_tmp208_).type));
		g_variant_builder_add_value (&_tmp211_, g_variant_new_string ((*_tmp208_).name));
		g_variant_builder_add_value (&_tmp211_, g_variant_new_string ((*_tmp208_).url));
		g_variant_builder_add_value (&_tmp211_, g_variant_new_boolean ((*_tmp208_).last_used_server));
		_tmp212_ = (*_tmp208_).fields;
		g_variant_builder_init (&_tmp213_, G_VARIANT_TYPE ("a(sbva{sv})"));
		for (_tmp214_ = 0; _tmp214_ < (*_tmp208_).fields_length1; _tmp214_++) {
			GVariantBuilder _tmp215_;
			GVariantBuilder _tmp216_;
			GHashTableIter _tmp217_;
			gpointer _tmp218_;
			gpointer _tmp219_;
			g_variant_builder_init (&_tmp215_, G_VARIANT_TYPE_TUPLE);
			g_variant_builder_add_value (&_tmp215_, g_variant_new_string ((*_tmp212_).type));
			g_variant_builder_add_value (&_tmp215_, g_variant_new_boolean ((*_tmp212_).required));
			g_variant_builder_add_value (&_tmp215_, g_variant_new_variant ((*_tmp212_).default_value));
			g_hash_table_iter_init (&_tmp217_, (*_tmp212_).properties);
			g_variant_builder_init (&_tmp216_, G_VARIANT_TYPE ("a{sv}"));
			while (g_hash_table_iter_next (&_tmp217_, &_tmp218_, &_tmp219_)) {
				gchar* _key;
				GVariant* _value;
				_key = (gchar*) _tmp218_;
				_value = (GVariant*) _tmp219_;
				g_variant_builder_add (&_tmp216_, "{?*}", g_variant_new_string (_key), g_variant_new_variant (_value));
			}
			g_variant_builder_add_value (&_tmp215_, g_variant_builder_end (&_tmp216_));
			g_variant_builder_add_value (&_tmp213_, g_variant_builder_end (&_tmp215_));
			_tmp212_++;
		}
		g_variant_builder_add_value (&_tmp211_, g_variant_builder_end (&_tmp213_));
		_tmp220_ = (*_tmp208_).applications;
		g_variant_builder_init (&_tmp221_, G_VARIANT_TYPE ("a(si)"));
		for (_tmp222_ = 0; _tmp222_ < (*_tmp208_).applications_length1; _tmp222_++) {
			GVariantBuilder _tmp223_;
			g_variant_builder_init (&_tmp223_, G_VARIANT_TYPE_TUPLE);
			g_variant_builder_add_value (&_tmp223_, g_variant_new_string ((*_tmp220_).application_id));
			g_variant_builder_add_value (&_tmp223_, g_variant_new_int32 ((*_tmp220_).pin_position));
			g_variant_builder_add_value (&_tmp221_, g_variant_builder_end (&_tmp223_));
			_tmp220_++;
		}
		g_variant_builder_add_value (&_tmp211_, g_variant_builder_end (&_tmp221_));
		g_variant_builder_add_value (&_tmp209_, g_variant_builder_end (&_tmp211_));
		_tmp208_++;
	}
	g_variant_builder_add_value (&_arguments_builder, g_variant_builder_end (&_tmp209_));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_connection_emit_signal (_connection, NULL, _path, "com.canonical.RemoteLogin", "LoginServersUpdated", _arguments, NULL);
}


static void _dbus_remote_login_service_login_changed (GObject* _sender, const gchar* url, const gchar* emailAddress, gpointer* _data) {
	GDBusConnection * _connection;
	const gchar * _path;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	_connection = _data[1];
	_path = _data[2];
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (url));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (emailAddress));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_connection_emit_signal (_connection, NULL, _path, "com.canonical.RemoteLogin", "LoginChanged", _arguments, NULL);
}


guint remote_login_service_register_object (gpointer object, GDBusConnection* connection, const gchar* path, GError** error) {
	guint result;
	gpointer *data;
	data = g_new (gpointer, 3);
	data[0] = g_object_ref (object);
	data[1] = g_object_ref (connection);
	data[2] = g_strdup (path);
	result = g_dbus_connection_register_object (connection, path, (GDBusInterfaceInfo *) (&_remote_login_service_dbus_interface_info), &_remote_login_service_dbus_interface_vtable, data, _remote_login_service_unregister_object, error);
	if (!result) {
		return 0;
	}
	g_signal_connect (object, "servers-updated", (GCallback) _dbus_remote_login_service_servers_updated, data);
	g_signal_connect (object, "login-servers-updated", (GCallback) _dbus_remote_login_service_login_servers_updated, data);
	g_signal_connect (object, "login-changed", (GCallback) _dbus_remote_login_service_login_changed, data);
	return result;
}


static void _remote_login_service_unregister_object (gpointer user_data) {
	gpointer* data;
	data = user_data;
	g_signal_handlers_disconnect_by_func (data[0], _dbus_remote_login_service_servers_updated, data);
	g_signal_handlers_disconnect_by_func (data[0], _dbus_remote_login_service_login_servers_updated, data);
	g_signal_handlers_disconnect_by_func (data[0], _dbus_remote_login_service_login_changed, data);
	g_object_unref (data[0]);
	g_object_unref (data[1]);
	g_free (data[2]);
	g_free (data);
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}



